

import Constants, random,svmutil
from sets import Set
import ClassifierOne, ClassifierTwo, DocPrepEngine

class CategorizationEngine():
    
    def __init__(self):
        
        #self.c1 = ClassifierOne.ClassifierOne()
        #self.c2=ClassifierTwo.ClassifierTwo()
        self.classifierMethodOne=None
        self.classifierMethodTwoPositive=None
        self.classifierMethodTwoNeutral=None
        self.classifierMethodTwoNegative=None
        self.docPrepEninge = DocPrepEngine.DocPrepEngine()
        
        self.vocabularyGlobal=[]
        self.vocabularyLocalPositive=[]
        self.vocabularyLocalNeutral=[]
        self.vocabularyLocalNegative=[]
        
    ################
    def trainingMethodOne(self,docs,SVMoptions=""):
        self.docPrepEninge.documentRepresentationsAll(docs, self.vocabularyGlobal) 
        print "vocab all: ",len(self.vocabularyGlobal)
        #self.c1.train([doc.category for doc in docs], [doc.doc_rep for doc in docs],SVMoptions)
        self.classifierMethodOne = svmutil.svm_train([doc.category for doc in docs], [doc.doc_rep for doc in docs],SVMoptions)

    
    def trainingMethodTwo(self,docs,SVMoptions=""):
        pos,nut,neg=self.docPrepEninge.divideDocsInPosNeutNeg(docs)
        posneg=pos+neg
        posnut=pos+nut
        negnut=neg+nut
        random.shuffle(posneg)
        random.shuffle(posnut)
        random.shuffle(negnut)
        pos=pos+negnut[:len(pos)]
        nut=nut+posneg[:len(nut)]
        neg=neg+posnut[:len(neg)]  
        print "pos/nut/neg: ",len(pos),len(nut),len(neg)
        
        
        self.docPrepEninge.documentRepresentationsAll(pos, self.vocabularyLocalPositive)
        print "pos vocab len: ",len(self.vocabularyLocalPositive)
        y=[]
        for doc in pos:
            if doc.category != Constants.SENTIMENT_POS: y.append(Constants.SENTIMENT_NONE)
            else: y.append(Constants.SENTIMENT_POS)
        self.classifierMethodTwoPositive = svmutil.svm_train(y, [doc.doc_rep for doc in pos],SVMoptions)
        
        
        self.docPrepEninge.documentRepresentationsAll(nut, self.vocabularyLocalNeutral)
        print "nut vocab len: ",len(self.vocabularyLocalNeutral)
        y=[]
        for doc in nut:
            if doc.category != Constants.SENTIMENT_NUT: y.append(Constants.SENTIMENT_NONE)
            else: y.append(Constants.SENTIMENT_NUT)
        self.classifierMethodTwoNeutral = svmutil.svm_train(y, [doc.doc_rep for doc in nut],SVMoptions)
        
        
        self.docPrepEninge.documentRepresentationsAll(neg, self.vocabularyLocalNegative)
        print "neg vocab len: ",len(self.vocabularyLocalNegative)
        y=[]
        for doc in neg:
            if doc.category != Constants.SENTIMENT_NEG: y.append(Constants.SENTIMENT_NONE)
            else: y.append(Constants.SENTIMENT_NEG)
        self.classifierMethodTwoNegative = svmutil.svm_train(y, [doc.doc_rep for doc in neg],SVMoptions)

    def testMethodOne(self,docs,thresh=0.0):
        #print "vocabulary size c1 (in cathenginge testing): ",len(self.c1.vocabularyGlobal)
        self.docPrepEninge.documentRepresentationsAll(docs, self.vocabularyGlobal)
        #print "doc rep o in ce: ",x[0].doc_rep
        #return self.c1.test([doc.category for doc in docs], [doc.doc_rep for doc in docs])
        p_label, p_acc, p_val = svmutil.svm_predict([doc.category for doc in docs], [doc.doc_rep for doc in docs], self.classifierMethodOne)
        
        #print p_label
        #print p_val
        #p_label=self.correctPLabeld(p_label, p_val, thresh)
        
        self.setPredictionInDocument(docs, p_label)
        
        return [p_label,p_acc,p_val]
    
    def testMethodTwo(self,docs,thresh=0.0):        
        self.docPrepEninge.documentRepresentationsAll(docs, self.vocabularyLocalPositive)
        p_label_pos, p_acc, p_val_pos = svmutil.svm_predict([doc.category for doc in docs],
                                                                               [doc.doc_rep for doc in docs], self.classifierMethodTwoPositive)
        self.docPrepEninge.documentRepresentationsAll(docs, self.vocabularyLocalNeutral)
        p_label_nut, p_acc, p_val_nut = svmutil.svm_predict([doc.category for doc in docs],
                                                                              [doc.doc_rep for doc in docs], self.classifierMethodTwoNeutral)
        self.docPrepEninge.documentRepresentationsAll(docs, self.vocabularyLocalNegative)
        p_label_neg, p_acc, p_val_neg = svmutil.svm_predict([doc.category for doc in docs],
                                                                               [doc.doc_rep for doc in docs], self.classifierMethodTwoNegative)
        #p_label_pos,p_label_nut,p_label_neg,p_val_pos,p_val_nut,p_val_neg= self.c2.test([doc.category for doc in docs], [doc.doc_rep for doc in docs])
        #TODO: Include p_val to pick label
                  
        
        #return (p_label_pos,p_label_nut,p_label_neg,p_val_pos,p_val_nut,p_val_neg)
        p_label=self.__mergePosNutNegClassifierResult(p_label_pos, p_label_nut, p_label_neg) 
        
        #self.setPredictionInDocument(docs, p_label)
        
        return p_label
    
    #################
    
    
    def correctPLabeld(self,labels,vals,thresh):
        if len(labels)==len(vals):
            for i in xrange(0,len(labels)):
                #print labels[i],max(vals[i])
                print labels[i],vals[i]
                if len(vals[i])>0:
                    if max(vals[i])<thresh: 
                        labels[i]=Constants.SENTIMENT_NONE
                        #print "Prediction not gooc enough"
        #else: print "ERROR: More values than labels in prediction"
        return labels
    
    def setPredictionInDocument(self,docs,p_labels):
        if len(docs)==len(p_labels):
            for i in xrange(len(docs)):
                docs[i].predicted_category=int(p_labels[i])
            

    def createVocabularyC1(self,docs,vocabSize):
        print "docs len: ",len(docs)
        self.vocabularyGlobal=self.docPrepEninge.featureReductionChi(docs, vocabSize)
        
    def createVocabulary(self,docs,vocabSize):
        if vocabSize>0:
            vocab1=self.docPrepEninge.featureReductionChi(docs, vocabSize)
            vocab=[]
            for w in vocab1:
                vocab.append(w[0])
            return vocab
        elif len(docs)>0: return docs[0].vocabulary
        
    #NOT USED, and not correct
    def createVocabulariesC2(self,docs,vocabSize):
        #pos,nut,neg=self.docPrepEninge.divideDocsInPosNeutNeg(docs)
        #posneg=pos+neg
        #posnut=pos+nut
        #negnut=neg+nut
        #r#andom.shuffle(posneg)
        #random.shuffle(posnut)
        #random.shuffle(negnut)
        self.vocabularyLocalNegative=self.docPrepEninge.featureReductionChi(docs, vocabSize)
        self.vocabularyLocalPositive=self.vocabularyLocalNegative
        self.vocabularyLocalNeutral=self.vocabularyLocalNegative
        
    #######################

    def __mergePosNutNegClassifierResult(self,p_label_pos,p_label_nut,p_label_neg):
        p_label=[]
        for i in xrange(len(p_label_pos)):
            if p_label_pos[i]!=Constants.SENTIMENT_NONE and p_label_nut[i] == p_label_neg[i]==Constants.SENTIMENT_NONE:
                p_label.append(p_label_pos[i])
            elif p_label_neg[i]!=Constants.SENTIMENT_NONE and p_label_nut[i] == p_label_pos[i]==Constants.SENTIMENT_NONE:
                p_label.append(p_label_neg[i])
            else:
                p_label.append(Constants.SENTIMENT_NUT)
        return p_label

    def makeTrainingSetMethodOne(self,pos,nut,neg,div=0.7):
        x,y=[],[]
        min1 = min(len(pos),len(nut),len(neg))
        for i in xrange(min1):
            y.append(Constants.SENTIMENT_POS)
            x.append(pos[i])
            y.append(Constants.SENTIMENT_NUT)
            x.append(nut[i])
            y.append(Constants.SENTIMENT_NEG)
            x.append(neg[i])
        div2 = int(len(y)*div)
        return {"yTraining":y[:div2],"xTraining":x[:div2],"yTesting":y[div2:],"xTesting":x[div2:]}
        
    
    def __mergePosNutNegTestSetToOne(self,ypos,xpos,ynut,xnut,yneg,xneg):
        y,x=[],[]
        for i in xrange(len(ypos)):
            if ypos[i]==Constants.SENTIMENT_POS:
                y.append(Constants.SENTIMENT_POS)
                x.append(xpos[i])
        for i in xrange(len(ynut)):
            if ynut[i]==Constants.SENTIMENT_NUT:
                y.append(Constants.SENTIMENT_NUT)
                x.append(xnut[i])
        for i in xrange(len(yneg)):
            if yneg[i]==Constants.SENTIMENT_NEG:
                y.append(Constants.SENTIMENT_NEG)
                x.append(xneg[i])
        return (y,x)
    
    
    def __getTrainingSetMethodTwoPositive(self,pos,nut,neg):
        y,x=[],[]
        min1 = min(len(pos),len(nut),len(neg))
        for i in xrange(min1):
            r = random.randint(0,1)    
            y.append(Constants.SENTIMENT_POS)
            x.append(pos[i])
            y.append(Constants.SENTIMENT_NONE)
            if r == 0: x.append(nut[i])
            else: x.append(neg[i])
        return (y,x)
    def __getTrainingSetMethodTwoNeutral(self,pos,nut,neg):
        y,x=[],[]
        min1 = min(len(pos),len(nut),len(neg))
        for i in xrange(min1):
            r = random.randint(0,1)    
            y.append(Constants.SENTIMENT_NUT)
            x.append(nut[i])
            y.append(Constants.SENTIMENT_NONE)
            if r == 0: x.append(pos[i])
            else: x.append(neg[i])
        return (y,x)
    def __getTrainingSetMethodTwoNegative(self,pos,nut,neg):
        y,x=[],[]
        min1 = min(len(pos),len(nut),len(neg))
        for i in xrange(min1):
            r = random.randint(0,1)    
            y.append(Constants.SENTIMENT_NEG)
            x.append(neg[i])
            y.append(Constants.SENTIMENT_NONE)
            if r == 0: x.append(nut[i])
            else: x.append(pos[i])
        return (y,x)
    
    def makeTrainingSetMethodTwo(self,pos,nut,neg,div=0.7):
        #Prepare training and test set for each of the three classifiers
        ypos,xpos=self.__getTrainingSetMethodTwoPositive(pos,nut,neg)
        ynut,xnut=self.__getTrainingSetMethodTwoNeutral(pos,nut,neg)
        yneg,xneg=self.__getTrainingSetMethodTwoNegative(pos,nut,neg)
        div2 = int(len(ypos)*div)
        #Prepare a common test set for each of the three classifiers
        y2test,x2test=self.__mergePosNutNegTestSetToOne(ypos[div2:],xpos[div2:],ynut[div2:],xnut[div2:],yneg[div2:],xneg[div2:])
        return {"yPosTraining":ypos[:div2],"xPosTraining":xpos[:div2],"yNutTraining":ynut[:div2],"xNutTraining":xnut[:div2],
                "yNegTraining":yneg[:div2],"xNegTraining":xneg[:div2], "yTesting":y2test,"xTesting":x2test}


    def makeClassifierSetFromDocs(self,docs):
        x,y=[],[]
        for doc in docs:
            y.append(doc.category)
            x.append(doc)
        return y,x

