'''
Created on 8. feb. 2011

@author: kimg
'''


from BeautifulSoup import BeautifulSoup
import urllib2,sys,urllib
import os
import ConfigAccess, Constants,LocalDataConnector


class CompanyInfoGatherer():
    
    def __init__(self):
        self.companiesPath = Constants.PATH_COMPANIES
        self.daily_prices = Constants.PATH_DAILY_PRICES
    
    def gatherStockInfoFromNetfonds(self):
        url = "http://hopey.netfonds.no/kurs.php"
        newurl = urllib.quote(url, safe="/:=&?#+!$,;'@()*[]")
        html_page = urllib2.urlopen(newurl)
        soup = BeautifulSoup(html_page)
        
        stockInfo =[]        
        
        for link in soup.findAll('a'):
            s = link.get('href')
            if "ppaper.php?paper=" in s: 
                pre = ConfigAccess.configAccess("links","netfonds")+s
                split = pre.split("ppaper")
                pre = split[0]+"about"+split[1] 
                url2 = pre
                newurl2 = urllib.quote(url2, safe="/:=&?#+!$,;'@()*[]")
                html_page2 = urllib2.urlopen(newurl2)
                soup2 = BeautifulSoup(html_page2)
                stockInfoInstance = {}
                for i in soup2.findAll('table',{ "id" : "updatetable1" }):
                    for j in i.findAll("tr"):
                        for k,l in map(None,j.findAll("th"),j.findAll("td")):
                            if k != None and l != None:
                                label = k.contents[0]
                                name = l.contents[0]
                                if  label == "Ticker":
                                    name = name.contents[0]
                                    stockInfoInstance[label]=name     
                                elif  label == "Navn":
                                    stockInfoInstance[label]=name     
                                elif label == "Indeks":
                                    name = name.contents[0]
                                    if "Indeks" in stockInfoInstance:
                                        stockInfoInstance["Indeks"].append(name)
                                    else:
                                        stockInfoInstance[label]=[name]
                                elif label == "Antall aksjer":
                                    stockInfoInstance[label]=name 
                
                #print stockInfoInstance
                stockInfo.append(stockInfoInstance)
        self.storeStockInfo(stockInfo)
                
    def storeStockInfo(self,info):
        if not os.path.exists(ConfigAccess.configAccess("data","data_path")):
            os.makedirs(ConfigAccess.configAccess("data","data_path"))
        if not os.path.exists(self.companiesPath):
            os.makedirs(self.companiesPath)
            
        file = open(self.companiesPath+"companies.txt", 'w')    #NOTE: windows path
        doc =""
        for stock in info:
            holder = "<name>"+stock["Navn"]+"</name>\n"
            if "Ticker" in stock: holder += "<ticker>"+stock["Ticker"]+"</ticker>\n"
            if "Antall aksjer" in stock: holder += "<stocks>"+stock["Antall aksjer"]+"</stocks>\n"
            if "Indeks" in stock:
                h = stock["Indeks"]
                for i in h:
                    #print i
                    holder += "<index>"+str(i)+"</index>\n"
            doc+="<company>\n"+holder+"</company>\n\n"
        file.write(doc)
        file.close()
        
        
    
    
    def gatherHistorikDailyPrices(self,tick):
        if not os.path.exists(ConfigAccess.configAccess("data","data_path")):
            os.makedirs(ConfigAccess.configAccess("data","data_path"))
        if not os.path.exists(self.daily_prices):
            os.makedirs(self.daily_prices)
            
        url = ConfigAccess.configAccess("links","netfonds")+"paperhistory.php?paper="+tick+".OSE&csv_format=txt"
        newurl = urllib.quote(url, safe="/:=&?#+!$,;'@()*[]")
        text = urllib2.urlopen(newurl).read()
        file = open(self.daily_prices+tick+".txt", 'w')    #NOTE: windows path
        file.write(text)
        file.close()
    def gatherHistorikDailyPricesAll(self):
        lc = LocalDataConnector.LocalDataConnector()
        for t in lc.getTickers():
            self.gatherHistorikDailyPrices(t)
       
        
if __name__ == "__main__":
    ci = CompanyInfoGatherer()
    ci.gatherStockInfoFromNetfonds()
    ci.gatherHistorikDailyPricesAll()