'''
Created on 22. feb. 2011

@author: kimg
'''

import math
from sets import Set
from scipy import linalg,array,dot,mat



"""
def chiSquare(catDocs,restDocs):
    if len(catDocs)>0:
        av={}
        n = len(catDocs)+len(restDocs)
        for term in catDocs[0].invertedIndex.getTerms():
            a,b,c,d = 0,0,0,0
            for doc in catDocs:
                if doc.invertedIndex.getDocTermCount(term,doc.id)>0: a+=1
                else: c+=1
            for doc in restDocs:
                if doc.invertedIndex.getDocTermCount(term,doc.id)>0: b+=1
                else: d+=1
            thresh=5
            #print a,b,c,d
            if a<thresh or b<thresh or c<thresh or d<thresh:    
                av[term]=0.0
            else:    
                bt=float(1.0*((a+c)*(b+d)*(a+b)*(c+d)))
                if bt==0: av[term]=0.0
                else: av[term]= 1.0*float(n*((a*d-c*b)**2)) / bt
        return av   
"""    
    
def chiSquare(categories):
    if len(categories)>0 and len(categories[0])>0:
        #print "Start CHI"
        av={}
        nc=len(categories)
        nr=2
        for term in categories[0][0].invertedIndex.getTerms():
            table=[]
            #--Init table
            for i in xrange(0,nr+1):
                row=[]
                for j in xrange(0,nc+1):
                    row.append(0)
                table.append(row)
            #print "0-----"
            #for i in table:
            #    print i
            #print "-----"
            
            #--Set values            
            for i in xrange(0,nc):
                for doc in categories[i]:
                    if doc.invertedIndex.getDocTermCount(term,doc.id)>0:
                        table[0][i]+=1
                    else: table[1][i]+=1
            #print "1-----"
            #for i in table:
            #   print i
            #print "-----"
            
            #--
            for i in xrange(0,nr):
                for j in xrange(0,nc):
                    table[i][-1]+=table[i][j]
            for j in xrange(0,nc):
                for i in xrange(0,nr):
                    table[-1][j]+=table[i][j]
            for i in xrange(0,nr):
                for j in xrange(0,nc):
                    table[-1][-1]+=table[i][j]
            
            #print "2-----"
            #for i in table:
            #    print i
            #print "-----"
            #---
            ok=True
            for i in xrange(0,nr):
                for j in xrange(0,nc):
                    if table[i][j]<5: ok=False
            
            #---
            if ok:
                sum=0.0
                for i in xrange(0,nr):
                    for j in xrange(0,nc):
                        excpected=((table[i][-1]*table[-1][j])/table[-1][-1])
                        sum+=(abs( table[i][j]-excpected )**2)/excpected
                av[term]=sum
            #else: av[term]=0.0
        #print "end CHI: ",av
        return av
    else: return {}
            
        
            

def chiSquareTopFeatures(catDocs,nr):
    vocab = sorted(chiSquare(catDocs).iteritems(), key=lambda (w,s): s, reverse=True)
    #print "len sorted vocab in fsmetric: ",len(vocab)
    if len(vocab)>nr: return vocab[:nr]
    else: return vocab
    
def chiSquareTopFeaturesVocab(catDocs,nr):
    vocab = chiSquareTopFeatures(catDocs,nr)
    v=[]
    for x in vocab: v.append(x[0])
    return v

def chiSquareTopFeaturesThersh(catDocs,thersh=4.7):
    vocab = sorted(chiSquare(catDocs).iteritems(), key=lambda (w,s): s, reverse=True)
    v=[]
    for x in vocab:
        if x[1]>thersh: v.append(x)
    return v

def chiSquareTopFeaturesThershVocab(catDocs,thersh=4.7):
    vocab = chiSquareTopFeaturesThersh(catDocs,thersh=4.7)
    v=[]
    for x in vocab: v.append(x[0])
    return v

#TODO: remove? used?
def TF(term,this,rest,thresh=0):
    ttc,trc=0,0
    if term in this.keys():
        ttc=this[term]
    if term in rest.keys():
        trc=rest[term]
    if ttc==0 or ttc<thresh: return 0
    else:   return ttc/float(ttc+trc)
    
    
    

def tfidf(matrix):
    
    termDocumentOccurencesVector=[]
    for i in xrange(len(matrix)):
        wordTotal= sum([1 for term in matrix[i] if term>0])
        #for term in matrix[i]:
        #    if term>0: wordTotal+=term
        for j in xrange(len(matrix[i])):
            if wordTotal == 0: matrix[i][j]=0.0
            else:
                wordTotal=wordTotal*1.0                
                tf = float(1.0*matrix[i][j] / wordTotal)   #Term frequency
                
                if len(termDocumentOccurencesVector)<j+1:
                    termDocumentOccurencesVector.append(0)
                    for k in xrange(len(matrix)):
                        if matrix[k][j]>0: termDocumentOccurencesVector[j]+=1 
                termDocumentOccurences = termDocumentOccurencesVector[j]                
                if termDocumentOccurences == 0: matrix[i][j]=0.0
                else:
                    termDocumentOccurences = termDocumentOccurences*1.0
                    idf=float(math.log10(abs(1.0*len(matrix)/termDocumentOccurences)))  #TODO: is log function correct type?????
                    matrix[i][j]=tf*idf
    #if len(matrix)>0:    print matrix[0]
    return matrix

def tfidf2(docs):
        
    for doc in docs:
        wordTotal= doc.invertedIndex.getDocLenght(doc.id)
        for term in doc.invertedIndex.getDocTerms(doc.id):
            if wordTotal == 0: doc.invertedIndex.addScore(doc.id,term,0.0)
            else:
                wordTotal=wordTotal*1.0                
                tf = float(1.0*doc.invertedIndex.getDocTermCount(term,doc.id) / wordTotal)   #Term frequency
                
                 
                termDocumentOccurences = doc.invertedIndex.getNumberOfDocumentsWithTerm(term)                
                if termDocumentOccurences == 0: doc.invertedIndex.addScore(doc.id,term,0.0)
                else:
                    termDocumentOccurences = termDocumentOccurences*1.0
                    idf=float(math.log10(abs(1.0*len(docs)/termDocumentOccurences)))  #TODO: is log function correct type?????
                    doc.invertedIndex.addScore(doc.id,term,tf*idf)
    #if len(matrix)>0:    print matrix[0]
    #return matrix
"""
for term in doc.term_counts.keys():  
        n = 0
        for i in doc.term_counts.keys():    #count number of words in doc
            n += doc.term_counts[i] 
        if n == 0: return 0  
        n=n*1.0
        tf = float(doc.term_counts[term] / n)   #Term frequency
        nd = 1 #+ sum([])
        for d in docs:  #Count document with given term in it
            if term in d.term_counts.keys(): nd +=1
        #if nd == 0: return 0
        nd = nd*1.0
        idf = float(math.log10(1.0*len(docs)/nd))  #TODO: is log function correct type?????
        doc.term_scores[term]= tf*idf
"""
    
    
def lsi(matrix,dimensions=0):
    """
    @type matrix: 2d list
    @param matrix: [terms][docs] ???
    """
    
    matrix = array(matrix)
    
    rows,cols= matrix.shape
    if dimensions<=0 and len(matrix)>0: dimensions=rows-1     
    print "rows in lsi: ",rows
    print "cols in lsi: ",cols
    print "dimensions: ",dimensions
    
    u,sigma,vt = linalg.svd(matrix)
    
    print "len sigma: ", len(sigma)
    #Dimension reduction
    for index in xrange(dimensions, len(sigma)):
        sigma[index]=0
    print "Min sigma: ",sigma[dimensions-1]
    print "Max sigma: ",sigma[0]
    nsigma=[i for i in sigma if i!=0]
    ns=[]
    for i in xrange(dimensions):
        h=[]
        for j in xrange(dimensions):
            h.append(0.0)
        ns.append(h)
    for i in xrange(len(nsigma)):
        ns[i][i]=nsigma[i]
    nu=[]
    for i in xrange(len(u)):
        h=[]
        for j in xrange(len(u[i])):
            if j < dimensions: h.append(u[i][j])
        nu.append(h)
    nvt=[]
    for i in xrange(len(vt)):
        if i < dimensions:
            h=[]
            for j in xrange(len(vt[i])):
                h.append(vt[i][j])
            nvt.append(h)
    #print len(nu[0]),len(nsigma),len(nvt)
    #print nu
    #print ns
    #print nvt
    #Reconstruct 
    #reconstructedMatrix= dot(dot(u,linalg.diagsvd(sigma,len(matrix),len(vt))),vt)
    #reconstructedMatrix= dot(nu,dot(ns,nvt))
    #reconstructedMatrix= dot(ns,nvt)
    reconstructedMatrix= dot(nu,ns)
    #matrix=reconstructedMatrix
    matrix=[]
    for row in reconstructedMatrix:
        mx=[]
        for collum in row:
            mx.append(collum)
        matrix.append(mx)
    return matrix
        
    
def sim_cosin(q,d):
    """
    Calculate cosin similarity between doc d and doc q
    
    @type q: list
    @param q: Document vecotr, length equal to d
    
    @type d: list
    @param d: Document vector, length equal to q
    
    @return: Similarity score
    """
    if len(q)!=len(d): return 0.0
    top = bq = bd = 0.0
    for i in xrange(len(q)):
        top = top + q[i]*d[i]   #Top part of the equation
        
        #The inner squeare part of each of the two bottom parts
        bq = bq + math.pow(q[i], 2)
        bd = bd + math.pow(d[i], 2)
    bq = math.sqrt(bq)
    bd = math.sqrt(bd)
    bottom = bq*bd  #Finished bottom part
    if bottom == 0.0: return 0.0    #Check for division by zero
    return float(top/bottom)






    
    