





class InvertedIndex():
    
    def __init__(self):
        self.index={}

    
    def addTerm(self,doc,term,count=1):
        if term in self.index:
            if doc in self.index[term]: self.index[term][doc][0]+=count
            else: self.index[term][doc]=[count,0.0]
        else:            
            h={}
            h[doc]=[count,0.0]
            self.index[term]=h
            
    def addScore(self,doc,term,score):
        if term in self.index:
            if doc in self.index[term]:
                self.index[term][doc][1]=score
                
                
                
    def getDocTermCount(self,term,doc):
        if term in self.index:
            if doc in self.index[term]:
                return self.index[term][doc][0]
        return 0
    def getDocTermScore(self,term,doc):
        if term in self.index:
            if doc in self.index[term]:
                return self.index[term][doc][1]
        return 0.0
            
    def getTotalTermCount(self,term):
        if term in self.index:
            return sum([x[0] for x in self.index[term].values()])
        else: return 0
    def getTotalTermScore(self,term):
        if term in self.index:
            return sum([x[1] for x in self.index[term].values()])
        else: return 0.0 
        
    def getNumberOfDocumentsWithTerm(self,term):
        if term in self.index:
            return len(self.index[term])
        else: return 0
            
    def getDocLenght(self,doc):
        #sum=0
        #for term in self.index.keys():
        #    if doc in self.index[term]:
        #        sum += self.index[term][doc][0]
        #return sum
        return sum([term[doc][0] for term in self.index.values() if doc in term])
    def getDocTerms(self,doc):
        return [term for term in self.index.keys() if doc in self.index[term]]
    
    def getTerms(self):
        return self.index.keys()   

    
    def removeTerm(self,term):
        if term in self.index:
            del self.index[term]
    def removeDoc(self,doc):
        for term in self.index.keys():
            if doc in self.index[term]: del self.index[term][doc]
        for term in self.index.keys():
            if len(self.index[term])==0: del self.index[term] 

