'''
Created on 18. feb. 2011

@author: kimg
'''

import ConfigAccess, HelperMethods,NewsArticleParseHelpers,LocalDataConnector,Constants
import nltk

class LanguageClassifier():
    
    def __init__(self):
        self.tsPath = Constants.PATH_LANGUAGE_CLASSIFIER_TS
        
        self.noDict=None
        self.engDict=None
        self.engFreq=None
        self.noFreq=None
        self.noStemmer = nltk.SnowballStemmer("norwegian")
        self.engStemmer = nltk.PorterStemmer()
    
    def createDictonarys(self):
        pNo=HelperMethods.getAllFilePaths(self.tsPath+"no\\")
        pEng=HelperMethods.getAllFilePaths(self.tsPath+"eng\\")
        
        ldc = LocalDataConnector.LocalDataConnector()
        
        sEng = ""
        for n in pEng:
            sEng += NewsArticleParseHelpers.getText(ldc.getNewsAllTextFromFilename(n))+"\n\n"
        sNo = ""
        for n in pNo:
            sNo += NewsArticleParseHelpers.getText(ldc.getNewsAllTextFromFilename(n))+"\n\n"
        sEng=sEng.lower()
        sNo=sNo.lower()
        noTokens = nltk.word_tokenize(sNo)
        engTokens = nltk.word_tokenize(sEng)
        
        noTokens = [self.noStemmer.stem(t) for t in noTokens]
        engTokens = [self.engStemmer.stem(t) for t in engTokens]
        
        self.noFreq=nltk.FreqDist(noTokens)
        self.engFreq=nltk.FreqDist(engTokens)
        
        self.noDict=set(self.noFreq.keys())
        self.engDict=set(self.engFreq.keys())
        
    def classify(self,doc):
        if self.engDict == None or self.engFreq==None or self.noDict==None or self.noFreq==None:
            self.createDictonarys()
        doc=doc.lower()
        docTokens = nltk.word_tokenize(doc)
        docFreq = nltk.FreqDist(docTokens)
        cNo=0
        cEng=0
        for key in docFreq.keys():
            if self.noStemmer.stem(key) in self.noDict:
                cNo+=docFreq[key]*self.noFreq[key]
            if self.engStemmer.stem(key) in self.engDict:
                cEng+=docFreq[key]*self.engFreq[key]
        thresh = 0.6
        #print cNo,cEng
        if cNo>cEng and (float(cEng)/float(cNo))<thresh: return "no"
        elif cNo<cEng and (float(cNo)/float(cEng))<thresh: return "eng"
        else: return ""
    
    
    
if __name__=="__main__":
    lc = LanguageClassifier()    
    lc.createDictonarys()
    print lc.classify("Dette dokumentet er skrevet paa Norsk")
    print lc.classify("This document is written in English")