'''
Created on 9. feb. 2011

@author: kimg
'''

from BeautifulSoup import BeautifulSoup,NavigableString
import HTMLParseHelpers,ConfigAccess,os,Constants

class LocalDataConnector():
    
    
    def __init__(self):
        self.companiesPath = Constants.PATH_COMPANIES
        self.daily_prices = Constants.PATH_DAILY_PRICES
        
        self.newsPathCat = Constants.PATH_NEWS_CATEGORIZED #TODO: Change!!!
    
    ####################################
    # Get stock company information - tickers, name given ticker....
    def getTickers(self):
        f = open(self.companiesPath+"companies.txt", "r")
        text = f.read()
        soup = BeautifulSoup(text)
        com = []
        for link in soup.findAll('company'):
            com.append(HTMLParseHelpers.getText(link.first("ticker"),"").strip())       
        f.close()
        return com
    
    def getCompanyName(self,tick):
        f = open(self.companiesPath+"companies.txt", "r")
        text = f.read()
        soup = BeautifulSoup(text)
        for link in soup.findAll('company'):
            if tick == HTMLParseHelpers.getText(link.first("ticker"),"").strip():
                return HTMLParseHelpers.getText(link.first("name"),"").strip()
        f.close()
    
    
    #######################################
    def isDateTradingDay(self,year,month,day,tick):
        f = open(self.daily_prices+tick+".txt", "r")
        if len(month)==1:month="0"+month
        if len(day)==1:day="0"+day
        date = year+month+day    
        for line in f.xreadlines():
            hline = line.split()
            if date == hline[0]:
                return True #TODO: check if correct
        f.close()
        return False
    
    #TODO: fix return if no prev or next date exist
    def getNextTradingDayDate(self,year,month,day,tick):
        f = open(self.daily_prices+tick+".txt", "r")
        if len(month)==1:month="0"+month
        if len(day)==1:day="0"+day
        date = int(year+month+day)    
        ndate = 999999999
        for line in f.xreadlines():
            hline = line.split()
            if len(hline[0])==8:
                d=int(hline[0])
                if d>date and d<=ndate:
                    ndate=d
        f.close()
        return str(ndate)
    def getPrevTradingDayDate(self,year,month,day,tick):
        f = open(self.daily_prices+tick+".txt", "r")
        if len(month)==1:month="0"+month
        if len(day)==1:day="0"+day
        date = int(year+month+day)    
        ndate = 0
        for line in f.xreadlines():
            hline = line.split()
            if len(hline[0])==8:
                d=int(hline[0])
                if d<date and d>ndate:
                    ndate=d
        f.close()
        return str(ndate)
    
    
    # Get stock quote info - open,close,high,low,volume - given date(s) and ticker
    def getQuoteDailyValue(self,year,month,day,tick,collum):
        f = open(self.daily_prices+tick+".txt", "r")
        if len(month)==1:month="0"+month
        if len(day)==1:day="0"+day
        date = year+month+day    
        for line in f.xreadlines():
            hline = line.split()
            if date == hline[0]:
                return hline[collum] #TODO: check if correct
        f.close()
        return ""
    
    def getQuoteDailyValues(self,sYear,sMonth,sDay,eYear,eMonth,eDay,tick,collum):
        prices = {}
        year = sYear
        month = sMonth
        day = sDay
        
        ok = True
        while ok:
            if len(month)==1:month="0"+month
            if len(day)==1:day="0"+day
            price = self.getQuoteDailyValue(year, month, day, tick,collum)
            date = year+month+day
            if price != "": prices[int(date)]=price
            
            if int(day)<31: day=str(int(day)+1)
            else:
                day="1"
                if int(month)<12: month = str(int(month)+1)
                else:
                    month="1"
                    year=str(int(year)+1)
            
            if year==eYear and month==eMonth and day==eDay: ok=False
        return prices
    
    
    def getQuoteDailyValuesNrDays(self,year,month,day,days,tick,collum):
        f = open(self.daily_prices+tick+".txt", "r")
        if len(month)==1:month="0"+month
        if len(day)==1:day="0"+day
        date = year+month+day    
        #l = {}
        l=[]
        ok = False
        count = 1
        for line in f.xreadlines():
            hline = line.split()
            if date == hline[0]:
                ok = True
            if count >days:
                ok=False
                return l
            if ok:  
                #l[hline[0]]=hline[collum] #TODO: check if correct
                l.append(hline[collum])
                count +=1
            
            
        f.close()
        return l
    
        
    def getPriceCloseDaily(self,year,month,day,tick):
        return self.getQuoteDailyValue(year, month, day, tick, 7)    
    def getPricesCloseDaily(self,sYear,sMonth,sDay,eYear,eMonth,eDay,tick):
        return self.getQuoteDailyValues(sYear, sMonth, sDay, eYear, eMonth, eDay, tick, 7)
    def getPricesCloseDailyNrDays(self,year,month,day,days,tick):
        return self.getQuoteDailyValuesNrDays(year, month, day, days, tick, 7)
    
    def getPriceOpenDaily(self,year,month,day,tick):
        return self.getQuoteDailyValue(year, month, day, tick, 4)    
    def getPricesOpenDaily(self,sYear,sMonth,sDay,eYear,eMonth,eDay,tick):
        return self.getQuoteDailyValues(sYear, sMonth, sDay, eYear, eMonth, eDay, tick, 4)    
    def getPricesOpenDailyNrDays(self,year,month,day,days,tick):
        return self.getQuoteDailyValuesNrDays(year, month, day, days, tick, 4)
    
    def getPriceHighDaily(self,year,month,day,tick):
        return self.getQuoteDailyValue(year, month, day, tick, 5)    
    def getPricesHighDaily(self,sYear,sMonth,sDay,eYear,eMonth,eDay,tick):
        return self.getQuoteDailyValues(sYear, sMonth, sDay, eYear, eMonth, eDay, tick, 5)
    def getPricesHighDailyNrDays(self,year,month,day,days,tick):
        return self.getQuoteDailyValuesNrDays(year, month, day, days, tick, 5)
    
    def getPriceLowDaily(self,year,month,day,tick):
        return self.getQuoteDailyValue(year, month, day, tick, 6)    
    def getPricesLowDaily(self,sYear,sMonth,sDay,eYear,eMonth,eDay,tick):
        return self.getQuoteDailyValues(sYear, sMonth, sDay, eYear, eMonth, eDay, tick, 6)
    def getPricesLowDailyNrDays(self,year,month,day,days,tick):
        return self.getQuoteDailyValuesNrDays(year, month, day, days, tick, 6)
    
    def getVolumeDaily(self,year,month,day,tick):
        return self.getQuoteDailyValue(year, month, day, tick, 8)    
    def getVolumValuesDaily(self,sYear,sMonth,sDay,eYear,eMonth,eDay,tick):
        return self.getQuoteDailyValues(sYear, sMonth, sDay, eYear, eMonth, eDay, tick, 8)
    def getVolumeValuesDailyNrDays(self,year,month,day,days,tick):
        return self.getQuoteDailyValuesNrDays(year, month, day, days, tick, 8)
    
    ####################################
    # Get news article information
    
    def getNewsAllTextFromFilename(self,pathFilename):
        f = open(pathFilename, "r")
        text = f.read()
        f.close()
        return text
    
    def getAllNewsNamesAndPaths(self):
        names= []
        for dirname, dirnames, filenames in os.walk(self.newsPathCat):
            h = dirname.split("\\")
            dir = h[len(h)-1]+"\\"
            
            for filename in filenames:
                names.append([dirname+"\\"+filename,dir[:len(dir)-1],filename])
        return names        
        
    
    
    
##################

if __name__ == "__main__":
    ci = LocalDataConnector()  
    #print ci.getCompanyName("TEL")
    #print ci.getPriceOpenDaily("2011", "2", "2", "BERGEN")
    #prices = ci.getPricesOpenDaily("2011", "1", "1", "2011", "2", "1", "BERGEN")
    #for date in prices:
    #    print date,prices[date]
    #print "333333333333333333333333333333333333333333333"
    #test = ci.getAllNewsNamesAndPaths()
    #print test[0][0]
    #print ci.getNewsAllTextFromFilename(test[0][0])
    
    
    
    