'''
Created on 8. feb. 2011

@author: kimg
'''


from BeautifulSoup import BeautifulSoup,NavigableString
import urllib2,sys,urllib
import re,os,sys
import urlparse,HelperMethods
import HTMLParseHelpers, CompanyInfoGatherer, ConfigAccess, LanguageClassifier, Constants
import TextPreprocessingTools, LocalDataConnector,sys,DBManager,NewsArticleParseHelpers
import codecs, NewsArticleParseHelpers


class NetfondsNewsGatherer():

    def __init__(self):
        self.netfonds = "netfonds"
        self.newsweb = "newsweb"
        self.hagnar = "Hegnar"
        self.tro ="Thomson Reuters ONE"        
        self.obi = "OBI"
        
        self.newsPathCat = Constants.PATH_NEWS_CATEGORIZED
        
        
        
        #self.nf_distr = [self.tro,self.obi,self.hagnar]
        self.nf_distr = [self.obi]
        self.sites = [self.netfonds]
        
        self.exchange = "OSE"
        
        self.langClassify = LanguageClassifier.LanguageClassifier()
        
        self.db = DBManager.DBManager()

    

    def gatherer(self,day,month,year,days,tick):
        self.db.initTable()
        doc = ""
        for site in self.sites:
            if site == self.netfonds:
                for distr in self.nf_distr:
                    
                    news_links = self.getLinksNetfonds(day, month, year, days, distr, tick, self.exchange)
                    
                    #work on news links inside netfonds
                    for nf_site in news_links:
                        try:
                            doc = []
                            doc = self.getDocumentsNetfonds(distr, nf_site)
                            #Check language
                            lang="" 
                            #if distr == self.obi:   #OBI publish in ENG and NO   
                            #    doc=[TextPreprocessingTools.ASCIItoSymbolsText(doc[0]),doc[1],doc[2],doc[3]]
                            #    lang = self.langClassify.classify(doc[0])
                            if distr == self.tro or distr == self.obi:   #tro publish in ENG and NO
                                lang = self.langClassify.classify(NewsArticleParseHelpers.getTextBody(doc[0]))
                                print lang
                            elif distr == self.hagnar:
                                lang="no"                            
                            if lang != "" and doc != []:
                                path = "categorized\\"+lang+"\\"+tick+"\\"
                                date = self.prepDate(doc[1])
                                time = self.prepTime(doc[2])
                                name = date+" "+time+" "+tick+" "+self.prepTitle(distr)+" "+self.prepTitle(doc[3].split("\n")[0])+".txt"
                                #name = date+" "+time+" "+tick+" "+str(distr)+".txt"
                                self.db.addNews(date, time, path, name, distr, NewsArticleParseHelpers.getSourceLink(doc[0]),lang)
                                self.db.addNewsCategory(name, tick)
                                self.storeDoc(doc[0], name, path)
                            elif lang=="": print sys.stderr.write("FAILED: To test language")
                        except Exception, err:
                            sys.stderr.write('FAILED: Doc retrieval\nERROR: %s\n' % str(err))
                            #print "FAILED: Doc retrieval"
            
        return doc
            
    ##############################
    # STORE doc to disc
    # date (pref. year,moth,day), time (h,m,s), tick, source, title
    #ex: 2011:01:29 12:54:13 TEL xx_yy title_is_something .txt
    def storeDoc(self,doc,name,path):
        if not os.path.exists(Constants.PATH_NEWS+path):
            os.makedirs(Constants.PATH_NEWS+path)
        file = codecs.open(Constants.PATH_NEWS+path+name, 'w','iso-8859-15')    #NOTE: windows path
        file.write(doc)
        file.close()
    
    ##########################
    # 
    def prepDate(self,date):
        h1 = date.split("-")
        d = h1[1]
        h2 = h1[0].split("/")
        d +=h2[1]
        d+=h2[0]
        return d
    def prepTitle(self,title):
        ht = title.split(" ")
        t = ""
        for i in ht:
            if len(i)>0:
                t+=i+"_"
        t = t[:len(t)-1]
        if len(t)>10:
            t = t[:10]
        #me= HelperMethods.rstr(t.encode('utf-8'))
        #t= me.remove('\\\"#%&/(()=?`|@{[]}+`^~\'*-_.:,;<>')
        t = urllib.quote(t.encode("iso-8859-15"), safe="&#+!$,;'@()[]".encode("iso-8859-15"))
        return t
    def prepTime(self,time):
        ht = time.split(":")
        return ht[0]+ht[1]+ht[2]
        

    ###################################
    # Get text 
    # RETURNS [doc, date, time, title]
    def getDocumentsNetfonds(self,distr,nf_site):
        
        newurl = urllib.quote(nf_site, safe="/:=&?#+!$,;'@()*[]")
        html = urllib2.urlopen(newurl).read() 
        soup = BeautifulSoup(html)
        h1 = HTMLParseHelpers.getText(soup.findAll("h1"),"")                        #Title
        #p = self.getText(soup.findAll("p", { "class" : "body" }),"")    #Text body
        #print h1
        #get date and time
        lh1 = h1.split()
        date = lh1[0]
        time = lh1[1][:len(lh1[1])-1]
        #print date,time
        
        #get text
        
        body =""
        title=""
        link=nf_site
        #If news source is Hegnar
        if distr == self.hagnar:
            text = self.getLinkOutFromNetfonds(soup,ConfigAccess.configAccess("links","hegnar"))
            soup2 = BeautifulSoup(text[0])
            link = text[1]
            title += HTMLParseHelpers.getTextTitleTro(soup)
            body+=HTMLParseHelpers.getTextBodyHegnar(soup2)
        elif distr == self.tro or distr == self.obi:
            title += HTMLParseHelpers.getTextTitleTro(soup)
            body += HTMLParseHelpers.getTextBodyTro(soup)
            
        
        doc=""
        doc += "<date>\n"+date+"\n</date>\n\n"
        doc+="<time>\n"+time+"\n</time>\n\n"
        doc+="<source_link>\n"+link+"\n</source_link>\n\n"
        doc+="<source>\n"+distr+"\n</source>\n\n"
        txt = "<title>\n"+title+"\n</title>\n\n"
        txt+="<body>\n"+body+"\n</body>\n"
        txt = "<text>\n"+txt+"</text>"
        doc+=txt    
        doc = "<doc>\n"+doc+"\n</doc>"
        
        return [doc,date,time,title]  #TODO: return (doc, filename), or something like it
    
    ################
    # Get links from netfonds summary article and out to original source
    def getLinkOutFromNetfonds(self,soup,url):
        d=""
        l =""
        for link in soup.findAll('a'):
            s = link.get('href')            
            if url in s :
                l=s
                #This might not work
                #d= urllib.quote(urllib2.urlopen(s).read(), safe="!\"#%&/(()=?`|@{[]}+`^~'*-_.:,;<>")
                d= urllib2.urlopen(s).read()#.encode('utf-8')
                
        return [d,l]
               
    ########################
    # Gather links to netfonds summary articles
    def getLinksNetfonds(self,day,month,year,days,distr,tick,exchange):
        page_size = 50
        page = 1
        last_link_size = -1
        news_links = []
        #Gather link to news inside netfonds
        while(last_link_size < len(news_links)):
            last_link_size = len(news_links)                
            url = ConfigAccess.configAccess("links","netfonds")+"releases.php?day="+str(day)+"&month="
            url+=   str(month)+"&year="+str(year)+"&days="+str(days)+"&distributor="
            url+=   str(distr)+"&paper="+tick+"&exchange="+exchange+"&search=&page_size="
            url+=   str(page_size)+"&page="+str(page)
            #print url
            newurl = urllib.quote(url, safe="/:=&?#+!$,;'@()*[]")
            html_page = urllib2.urlopen(newurl)
            
            soup = BeautifulSoup(html_page)
            for link in soup.findAll('a'):
                s = link.get('href')
                #print s
                if "release.php?id=" in s and str(distr) in s: 
                    news_links.append(ConfigAccess.configAccess("links","netfonds")+s)
            page+=1
        #print len(news_links)
        return news_links
       
       
            
if __name__ == "__main__":
    print "Enter Day/Moth/Year to specefy with date to start gathering news, then enter Dys to specefy how many days back to gather from"
    day = int(raw_input("Day: "))
    month = int(raw_input("Month: "))
    year = int(raw_input("Year: "))
    years = 10
    days = 364*years
    days = int(raw_input("Days back: "))
    tick = raw_input("Enter Ticker to gahter news from or leev blank to gather from all: ")
    nf = NetfondsNewsGatherer()
    com = LocalDataConnector.LocalDataConnector()    
    if tick == "":
        tickers = com.getTickers()
        for ticker in tickers:
            nf.gatherer(day,month,year,days,ticker)   
    else:
        nf.gatherer(day,month,year,days,tick)
   
