'''
Created on 7. mars 2011

@author: kimg
'''


import Constants
import sys,os

class Ticker():
    
    
    
    def __init__(self, ticker):
        
        self.ticker = ticker
        self.quote_daily = []
        self.quote_intra = {}
        self.quote={}
        self.ok = self.initdaily()
        #self.initIntra()
    
    def initdaily(self):
        try:
            print "Retrieve daily ticker info from disc on: ",self.ticker
            f = open(Constants.PATH_DAILY_PRICES+self.ticker+".txt", "r")
            for line in f.xreadlines():
                hline = line.split()
                holder = []
                holder.append(hline[0])
                holder.append(hline[4])
                holder.append(hline[5])
                holder.append(hline[6])
                holder.append(hline[7])
                holder.append(hline[8])
                self.quote_daily.append(holder)
            self.quote_daily.reverse()
            del self.quote_daily[-1]
            return True
                
        except Exception, err:
                sys.stderr.write('ERROR: %s\n' % str(err))
    
    def initIntra(self):        
        dur = 10
        dir = os.listdir(Constants.PATH_INTRA_PRICES+self.ticker+"\\")
        comp = self.ticker+"_"
        for d in dir:
            if comp in d:
                #try:
                    f = open(Constants.PATH_INTRA_PRICES+self.ticker+"\\"+d, "r")
                    date = ""
                    #count=1
                    for line in  f.xreadlines():
                        hline = line.split()
                        holder=[]
                        #print line
                        if len(hline)==3: date = hline[0]+hline[1]+hline[2]
                        elif len(hline)==5:
                            #holder.append(date)
                            holder.append(hline[0]+hline[1]+hline[2])   #Time
                            holder.append(hline[3])                     #Price
                            holder.append(hline[4])                     #volume
                            #If no trade on date
                            if date not in self.quote_intra.keys():
                                self.quote_intra[date]=[holder]
                            #     count=1
                            # elif int(self.quote_intra[date][-1][0][2:4])+dur > int(holder[0][2:4]):
                            #     count+=1
                            #     self.quote_intra[date][-1][1] = float(self.quote_intra[date][-1][1])*(float(count-1)/float(count))+float(holder[1])*(float(1)/float(count))
                            #     self.quote_intra[date][-1][2] += holder[2] 
                            else:
                                self.quote_intra[date].append(holder)
                            #     count=1
                                
                        
                #except Exception, err:
                #    sys.stderr.write('ERROR: %s\n' % str(err))
        
    
 
    
    
    ########################################
    
    def isDateTradingDay(self,date): 
        for line in self.quote_daily:
            if date == line[0]:
                return True 
        return False
    def isYearMonthDayTradingDay(self,year,month,day):
        if len(month)==1:month="0"+month
        if len(day)==1:day="0"+day
        date = year+month+day    
        return self.isDateTradingDay(date)
    
    #TODO: fix return if no prev or next date exist
    def getNextTradingDayDate(self,year,month,day):
        if len(month)==1:month="0"+month
        if len(day)==1:day="0"+day
        date = int(year+month+day)    
        ndate = 999999999
        for line in self.quote_daily:
            if len(line[0])==8:
                d=int(line[0])
                if d>date and d<=ndate:
                    ndate=d
        return str(ndate)
    def getPrevTradingDayDate(self,year,month,day):
        if len(month)==1:month="0"+month
        if len(day)==1:day="0"+day
        date = int(year+month+day)    
        ndate = 0
        for line in self.quote_daily:
            if len(line[0])==8:
                d=int(line[0])
                if d<date and d>ndate:
                    ndate=d
        return str(ndate)
    
    
    
    
    
    #########################
    def isDateTradingDayIntra(self,year,month,day):
        if len(month)==1:month="0"+month
        if len(day)==1:day="0"+day
        date = year+month+day    
        if date in self.quote_intra.keys():
            return True 
        return False
    #TODO: fix return if no prev or next date exist
    def getNextTradingDayDateIntra(self,year,month,day):
        if len(month)==1:month="0"+month
        if len(day)==1:day="0"+day
        date = int(year+month+day)    
        ndate = 999999999
        for line in sorted(self.quote_intra.keys()):
            if int(line)>date and int(line)<=ndate:
                ndate=line
        return str(ndate)
    def getPrevTradingDayDateIntra(self,year,month,day):
        if len(month)==1:month="0"+month
        if len(day)==1:day="0"+day
        date = int(year+month+day)    
        ndate = 0
        for line in sorted(self.quote_intra.keys()):
            if int(line)<date and int(line)>ndate:
                ndate=line
        return str(ndate)
    
    #######################
    #date = yyyymmdd  time = hhmmss
    def getNextTradeTime(self,date,time):
        list = self.quote_intra[date]
        if list != None:
            for t in list:
                if int(t) > int(time):
                    return t
            
        l = self.quote_intra[self.getNextTradingDayDateIntra(date)]
        if l != None: return l[0]
        else: return None
        
    def getPrevTradeTime(self,date,time):
        list = self.quote_intra[date]
        if list != None:
            for t in xrange(len(list)-1,-1,-1):
                if int(t) < int(time):
                    return t
            
        l = self.quote_intra[self.getPrevTradingDayDateIntra(date)]
        if l != None: return l[-1]
        else: return None
    
    ###################################
    
    
    
    def isTradeInNextHourMin(self,date,time,nhour,nmin):
        if date in self.quote_intra.keys():
            list = self.quote_intra[date]
            ok = False
            hour = str(int(time[4:6])+int(nhour))
            if len(hour)==0:hour="00"
            elif len(hour)==1:hour="0"+hour
            elif len(hour)>2: hour=hour[-2:]
            min = str(int(time[4:6])+int(nhour))
            if len(min)==0:min="00"
            elif len(min)==1:min="0"+min
            elif len(min)>2: min=min[-2:]
            next = hour+min+"00"
            count = 0
            for i in list:
                if int(i[0]) > int(time) and int(i[0]) < int(next):
                     count+=1
            if count>1: return True
            else: return False
        else: return False
                
    
    def getQuoteIntraValue(self,year,month,day,collum,hour=-1,min=-1,sec=-1):
        if len(month)==1:month="0"+month
        if len(day)==1:day="0"+day
        date = year+month+day    
        for line in self.quote_daily:
            if date == line[0]:
                return line[collum] 
        return ""
    
    def getQuoteIntraValues(self,sYear,sMonth,sDay,eYear,eMonth,eDay,collum,shour=-1,smin=-1,ssec=-1,ehour=-1,emin=-1,esec=-1):
        prices = {}
        year = sYear
        month = sMonth
        day = sDay
        
        ok = True
        while ok:
            if len(month)==1:month="0"+month
            if len(day)==1:day="0"+day
            price = self.getQuoteDailyValue(year, month, day,collum)
            date = year+month+day
            if price != "": prices[int(date)]=price
            
            if int(day)<31: day=str(int(day)+1)
            else:
                day="1"
                if int(month)<12: month = str(int(month)+1)
                else:
                    month="1"
                    year=str(int(year)+1)
            
            if year==eYear and month==eMonth and day==eDay: ok=False
        return prices
    
    
    def getQuoteIntraValuesNrDays(self,date,time,hours,minutes,type=Constants.TICKER_PRICE_TYPE_INTRA):
        l=[]
        coll=-1
        if type==Constants.TICKER_PRICE_TYPE_VOLUME: coll=2
        else: coll = 1
        if date in self.quote_intra.keys():
            list = self.quote_intra[date]
            hour = str(int(time[4:6])+int(hours))
            if len(hour)==0:hour="00"
            elif len(hour)==1:hour="0"+hour
            elif len(hour)>2: hour=hour[-2:]
            min = str(int(time[4:6])+int(minutes))
            if len(min)==0:min="00"
            elif len(min)==1:min="0"+min
            elif len(min)>2: min=min[-2:]
            next = hour+min+"00"
            
            for i in list:
                if int(i[0]) > int(time) and int(i[0]) < int(next):
                    l.append(float(i[coll]))       
        return l
    
    ###############
    
    def getQuoteDailyValue(self,year,month,day,collum):
        if len(month)==1:month="0"+month
        if len(day)==1:day="0"+day
        date = year+month+day    
        for line in self.quote_daily:
            if date == line[0]:
                return line[collum] 
        return ""
    
    def getQuoteDailyValues(self,sYear,sMonth,sDay,eYear,eMonth,eDay,collum):
        prices = {}
        year = sYear
        month = sMonth
        day = sDay
        
        ok = True
        while ok:
            if len(month)==1:month="0"+month
            if len(day)==1:day="0"+day
            price = self.getQuoteDailyValue(year, month, day,collum)
            date = year+month+day
            if price != "": prices[int(date)]=price
            
            if int(day)<31: day=str(int(day)+1)
            else:
                day="1"
                if int(month)<12: month = str(int(month)+1)
                else:
                    month="1"
                    year=str(int(year)+1)
            
            if year==eYear and month==eMonth and day==eDay: ok=False
        return prices
    
    
    def getQuoteDailyValuesNrDays(self,year,month,day,days,collum):
        if len(month)==1:month="0"+month
        if len(day)==1:day="0"+day
        date = year+month+day
        l=[]
        ok = False
        count = 1
        for line in self.quote_daily:
            if date == line[0]:
                ok = True
            if count >days:
                ok=False
                return l
            if ok:  
                #l[hline[0]]=hline[collum] #TODO: check if correct
                l.append(line[collum])
                count +=1
        #print self.quote_daily
        #print l
        return l
    
    
    
    
    def getPriceCloseDaily(self,year,month,day):
        return self.getQuoteDailyValue(year, month, day, 4)    
    def getPricesCloseDaily(self,sYear,sMonth,sDay,eYear,eMonth,eDay):
        return self.getQuoteDailyValues(sYear, sMonth, sDay, eYear, eMonth, eDay, 4)
    def getPricesCloseDailyNrDays(self,year,month,day,days):
        return self.getQuoteDailyValuesNrDays(year, month, day, days, 4)
    
    def getPriceOpenDaily(self,year,month,day):
        return self.getQuoteDailyValue(year, month, day, 1)    
    def getPricesOpenDaily(self,sYear,sMonth,sDay,eYear,eMonth,eDay):
        return self.getQuoteDailyValues(sYear, sMonth, sDay, eYear, eMonth, eDay, 1)    
    def getPricesOpenDailyNrDays(self,year,month,day,days):
        return self.getQuoteDailyValuesNrDays(year, month, day, days, 1)
    
    def getPriceHighDaily(self,year,month,day):
        return self.getQuoteDailyValue(year, month, day, 2)    
    def getPricesHighDaily(self,sYear,sMonth,sDay,eYear,eMonth,eDay):
        return self.getQuoteDailyValues(sYear, sMonth, sDay, eYear, eMonth, eDay, 2)
    def getPricesHighDailyNrDays(self,year,month,day,days):
        return self.getQuoteDailyValuesNrDays(year, month, day, days, 2)
    
    def getPriceLowDaily(self,year,month,day):
        return self.getQuoteDailyValue(year, month, day, 3)    
    def getPricesLowDaily(self,sYear,sMonth,sDay,eYear,eMonth,eDay):
        return self.getQuoteDailyValues(sYear, sMonth, sDay, eYear, eMonth, eDay, 3)
    def getPricesLowDailyNrDays(self,year,month,day,days):
        return self.getQuoteDailyValuesNrDays(year, month, day, days, 3)
    
    def getVolumeDaily(self,year,month,day):
        return self.getQuoteDailyValue(year, month, day, 5)    
    def getVolumValuesDaily(self,sYear,sMonth,sDay,eYear,eMonth,eDay):
        return self.getQuoteDailyValues(sYear, sMonth, sDay, eYear, eMonth, eDay, 5)
    def getVolumeValuesDailyNrDays(self,year,month,day,days):
        return self.getQuoteDailyValuesNrDays(year, month, day, days, 5)