


import DBManager,TickerManager
import Constants,random

class TradingEngine():

    def __init__(self):
        self.tickers = TickerManager.TickerManager()
    
        self.openingtime=90000
        self.closingtime=172000
       
        self.returnPosNews=0.0
        self.returnNegNews=0.0
        self.returnPosRandom=0.0
        self.returnNegRandom=0.0
        self.nrNegNewsTrades=0
        self.nrPosNewsTrades=0
        self.nrNegRandomTrades=0
        self.nrPosRandomTrades=0
        self.returnMarket=0.0
        self.returnMax=0.0
        
    def initStats(self):
        self.returnPosNews=0.0
        self.returnNegNews=0.0
        self.returnPosRandom=0.0
        self.returnNegRandom=0.0
        self.nrNegNewsTrades=0
        self.nrPosNewsTrades=0
        self.nrNegRandomTrades=0
        self.nrPosRandomTrades=0
        self.returnMarket=0.0
        self.returnMax=0.0
        self.nrTradesPosible=0
    
    
    def tradingMethodOneIntra(self,docs,hours="00",minutes="00",tickers=None):
        self.initStats()
        if tickers!=None: self.tickers=tickers
        for doc in docs:
            #doc.predicted_category=doc.category #TEMP remove later
            if doc.predicted_category!=None:
                ticker=self.tickers.getTicker(doc.ticker)   
                if ticker.isDateTradingDay(doc.date) and ticker.isTradeInNextHourMin(doc.date, doc.time, hours, minutes):   
                    prices=ticker.getQuoteIntraValuesNrDays(doc.date,doc.time,hours,minutes)
                    if len(prices)>1:
                        start,end=prices[0],prices[-1] 
                        if doc.predicted_category==Constants.SENTIMENT_POS: 
                            self.tradePosNews(start,end)
                            #self.tradeNegNews(start,end)
                        elif doc.predicted_category==Constants.SENTIMENT_NEG: 
                            self.tradeNegNews(start,end)
                            #self.tradePosNews(start,end)
                        self.tradeRandom(start,end)
                        self.tradeMarketReturn(start, end)
                        self.tradeMaxReturn(start, end)
                        self.nrTradesPosible+=1
    
    def tradingMethodOneDaily(self,docs,days=1,tickers=None):
        
        if tickers!=None: self.tickers=tickers
        
        self.initStats()
        
        for doc in docs:
            
            #doc.predicted_category=doc.category #TEMP remove later
            
            if doc.predicted_category!=None:
                ticker=self.tickers.getTicker(doc.ticker)
                close=ticker.getPricesCloseDailyNrDays(doc.date[:4], doc.date[4:6], doc.date[6:],days+1)
                open=ticker.getPricesOpenDailyNrDays(doc.date[:4], doc.date[4:6], doc.date[6:],days+1)
                start,end=None,None                
                #print doc.predicted_category
                #print close
                #print open
                if len(close)>0 and len(open)>0:
                    if int(doc.time)>self.openingtime and int(doc.time)<self.closingtime: 
                        #print "open"   
                        start=close[0]
                        if len(open)>2: end=close[-2]
                        else: end=close[-1]
                    elif int(doc.time)<self.openingtime: 
                        #print "before"
                        start=open[0]
                        if len(open)>2: end=close[-2]
                        else: end=close[-1]
                    elif int(doc.time)>self.closingtime and len(close)>1 and len(open)>1:
                        #print "close"
                        start=open[1]
                        if len(open)>2: end=close[-2]
                        else: end=close[-1]                  
                    if start!=None and end!=None:
                        if doc.predicted_category==Constants.SENTIMENT_POS: 
                            self.tradePosNews(start,end)
                            #self.tradeNegNews(start,end)
                        elif doc.predicted_category==Constants.SENTIMENT_NEG: 
                            self.tradeNegNews(start,end)
                            #self.tradePosNews(start,end)
                        self.tradeRandom(start,end)
                        self.tradeMarketReturn(start, end)
                        self.tradeMaxReturn(start, end)
                        self.nrTradesPosible+=1
                    
    def tradingMethodTwoDaily(self,docs,days=1,tickers=None):
        
        if tickers!=None: self.tickers=tickers
        
        self.initStats()
        
        for doc in docs:
            
            #doc.predicted_category=doc.category #TEMP remove later
            
            if doc.predicted_category!=None:
                ticker=self.tickers.getTicker(doc.ticker)
                
                close=ticker.getPricesCloseDailyNrDays(doc.date[:4], doc.date[4:6], doc.date[6:],days+1)
                open=ticker.getPricesOpenDailyNrDays(doc.date[:4], doc.date[4:6], doc.date[6:],days+1)
                start,end=None,None
                prices=ticker.getQuoteIntraValuesNrDays(doc.date,doc.time,"00","30")             
                if len(prices)>0: start=prices[0]   
                #print doc.predicted_category
                #print close
                #print open
                if len(close)>0 and len(open)>0 and len(prices)>0:
                    if int(doc.time)>self.openingtime and int(doc.time)<self.closingtime: 
                        #print "open"   
                        if start==None:start=close[0]
                        if len(open)>2: end=close[-2]
                        else: end=close[-1]
                    elif int(doc.time)<self.openingtime: 
                        #print "before"
                        if start==None:start=open[0]
                        if len(open)>2: end=close[-2]
                        else: end=close[-1]
                    elif int(doc.time)>self.closingtime and len(close)>1 and len(open)>1:
                        #print "close"
                        if start==None:start=open[1]
                        if len(open)>2: end=close[-2]
                        else: end=close[-1]                  
                    if start!=None and end!=None:
                        if doc.predicted_category==Constants.SENTIMENT_POS: 
                            self.tradePosNews(start,end)
                            #self.tradeNegNews(start,end)
                        elif doc.predicted_category==Constants.SENTIMENT_NEG: 
                            self.tradeNegNews(start,end)
                            #self.tradePosNews(start,end)
                        self.tradeRandom(start,end)
                        self.tradeMarketReturn(start, end)
                        self.tradeMaxReturn(start, end)
                        self.nrTradesPosible+=1
    
    def tradePosNews(self,start,end):
        #print "buy"
        start=float(start)
        end=float(end)
        ret=end-start
        self.returnPosNews+=ret/start
        self.nrPosNewsTrades+=1
    def tradeNegNews(self,start,end):
        #print "sell"
        start=float(start)
        end=float(end)
        ret=start-end
        self.returnNegNews+=ret/start
        self.nrNegNewsTrades+=1
    
    def tradeRandom(self,start,end):
        start=float(start)
        end=float(end)
        rand = random.randint(0,2)
        if rand==0:
            ret=end-start
            self.returnPosRandom+=ret/start
            self.nrPosRandomTrades+=1
        elif rand==1:
            ret=start-end
            self.returnNegRandom+=ret/start
            self.nrNegRandomTrades+=1
        

    def tradeMarketReturn(self,start,end):
        start=float(start)
        end=float(end)
        ret=end-start
        self.returnMarket+=ret/start

    def tradeMaxReturn(self,start,end):
        start=float(start)
        end=float(end)
        ret=max(start-end,end-start)
        self.returnMax+=ret/start



