'''
Created on 11. feb. 2011

@author: kimg

TODO:
Add - If Before and after prices has same trend direction but after has gotten a more extreame trend angle, then mark it as pos/neg instead of none
'''

import LocalDataConnector, NewsArticleParseHelpers,ConfigAccess,HelperMethods, Constants
import os,re
import DBManager
import nltk
import random
import TickerManager
from BeautifulSoup import BeautifulSoup
import ConfigAccess


class NewsTrainingSetCreator():
    
    def __init__(self):
        self.newsPathCat = Constants.PATH_NEWS_CATEGORIZED
        self.daily_prices = Constants.PATH_DAILY_PRICES
        self.training_set = ConfigAccess.configAccess("data","data_path")+ConfigAccess.configAccess("data","training_set")
        
        self.dataConnector = LocalDataConnector.LocalDataConnector()
        self.tickers = TickerManager.TickerManager()
        self.db = DBManager.DBManager()
        #self.newsLinks = self.dataConnector.getAllNewsNamesAndPaths()
    
    def create(self):
        pass
    
    def findValues(self,date,time,tick,daysForward,openTime=90000,closeTime=172000):  
        
        year=date[:4]
        month=date[4:6]
        day=date[6:8]
        
        time=int(time)
        #hour=int(time[:2])
        #minute=int(time[2:4])
        
        
        
        
        ticker = self.tickers.getTicker(tick)
        price=[]
        #before=[]
        #beforeHigh=[]
        #beforeLow=[]
        close=ticker.getPricesCloseDailyNrDays(year,month,day,daysForward+1)
        open=ticker.getPricesOpenDailyNrDays(year,month,day,daysForward+1)
        high=ticker.getPricesHighDailyNrDays(year,month,day,daysForward+1)
        low=ticker.getPricesLowDailyNrDays(year,month,day,daysForward+1)
        #volume=[] 
        
        if time>closeTime:
            #print "after"
            if len(open)>2:
                price.extend(open[1:-1])
                price.extend(close[1:-1])
                high=high[1:-1]
                low=low[1:-1]
            else:
                price.extend(open[1:])
                price.extend(close[1:])
                high=high[1:]
                low=low[1:]
                                
        elif time<openTime:
            #print "before"
            price.extend(open[0:-1])
            price.extend(close[0:-1])
            high=high[0:-1]
            low=low[0:-1]
           
        else:
            #print "opening"
            if len(open)>2:
                price.extend(close[0:-1])
                price.extend(open[1:-1])                
                high=high[1:-1]
                low=low[1:-1]
            else:
                price.extend(close[0:])
                price.extend(open[1:])                
                high=high[1:]
                low=low[1:]
        
        return {"prices":price,"high":high,"low":low}
    
    def findValues2(self,date,time,tick,daysForward,openTime=900,closeTime=1820):  
        
        year=date[:4]
        month=date[4:6]
        day=date[6:8]
        
        time2=int(time[:4])
        hour=int(time[:2])
        minute=int(time[2:4])
        
        
        
        start=[]
        after=[]
        #before=[]
        #beforeHigh=[]
        #beforeLow=[]
        high=[]
        low=[]
        #volume=[] 
        ticker = self.tickers.getTicker(tick)
        
        #TODO: If not trading day, start=prev trading day closeTime and after = next trading days
        if not ticker.isDateTradingDay(date) or time2<openTime:
            pdate=ticker.getPrevTradingDayDate(year, month, day)
            pdate=HelperMethods.getYearMonthDayStringsFromFormatYYYYMMDD(pdate)
            start = ticker.getPricesCloseDailyNrDays(pdate[0], pdate[1], pdate[2], 1)
            
            #for i in xrange(daysBack):
            #    pdate=ticker.getPrevTradingDayDate(pdate[0], pdate[1], pdate[2])
            #    pdate=HelperMethods.getYearMonthDayStringsFromFormatYYYYMMDD(pdate)
            #before = ticker.getPricesCloseDailyNrDays(pdate[0], pdate[1], pdate[2], daysBack)
            #beforeHigh=ticker.getPricesHighDailyNrDays(pdate[0], pdate[1], pdate[2], daysBack)
            #beforeLow=ticker.getPricesLowDailyNrDays(pdate[0], pdate[1], pdate[2], daysBack)
            
            after = ticker.getPricesOpenDailyNrDays(year, month, day, 1)
            after.extend(ticker.getPricesCloseDailyNrDays(year, month, day, daysForward))
            
            high = ticker.getPricesHighDailyNrDays(year, month, day, daysForward)
            low = ticker.getPricesLowDailyNrDays(year, month, day, daysForward)
                    
        #If published during opening
        elif time2<closeTime:
            
            start = ticker.getPricesOpenDailyNrDays(year, month, day, 1)
            after = ticker.getPricesCloseDailyNrDays(year, month, day, daysForward)
            high = ticker.getPricesHighDailyNrDays(year, month, day, daysForward)
            low = ticker.getPricesLowDailyNrDays(year, month, day, daysForward)
            
            #pdate=""
            #for i in xrange(daysBack):
            #    pdate=ticker.getPrevTradingDayDate(year, month, day)
            #    pdate=HelperMethods.getYearMonthDayStringsFromFormatYYYYMMDD(pdate)
            #before = ticker.getPricesCloseDailyNrDays(pdate[0], pdate[1], pdate[2], daysBack)
            #beforeHigh=ticker.getPricesHighDailyNrDays(pdate[0], pdate[1], pdate[2], daysBack)
            #beforeLow=ticker.getPricesLowDailyNrDays(pdate[0], pdate[1], pdate[2], daysBack)
           
        #If published after closed
        else:
            start = ticker.getPricesCloseDailyNrDays(year, month, day, 1)
            
            #pdate=""
            #for i in xrange(daysBack):
            #    pdate=ticker.getPrevTradingDayDate(year, month, day)
            #    pdate=HelperMethods.getYearMonthDayStringsFromFormatYYYYMMDD(pdate)
            #before = ticker.getPricesCloseDailyNrDays(pdate[0], pdate[1], pdate[2], daysBack)
            #beforeHigh=ticker.getPricesHighDailyNrDays(pdate[0], pdate[1], pdate[2], daysBack)
            #beforeLow=ticker.getPricesLowDailyNrDays(pdate[0], pdate[1], pdate[2], daysBack)
            
            pdate=ticker.getNextTradingDayDate(year, month, day)
            pdate=HelperMethods.getYearMonthDayStringsFromFormatYYYYMMDD(pdate)
            
            after = ticker.getPricesOpenDailyNrDays(pdate[0], pdate[1], pdate[2], 1)
            after.extend(ticker.getPricesCloseDailyNrDays(pdate[0], pdate[1], pdate[2], daysForward))
            
            high = ticker.getPricesHighDailyNrDays(pdate[0], pdate[1], pdate[2], daysForward)
            low = self.tickers.getTicker(tick).getPricesLowDailyNrDays(pdate[0], pdate[1], pdate[2], daysForward)
        #print start
        return {"start":start,"high":high,"low":low,"after":after}
    
    
    def findValuesIntra(self,ticker,date,time,hours,minutes):
        
        prices=ticker.getQuoteIntraValuesNrDays(date,time,hours,minutes)
        if len(prices)==0: return {}
        low = [min(prices)]
        high  =[max(prices)]        
        return {"prices":prices,"high":high,"low":low}
    
 
    
    
    def generalMethodIntraOne(self,lang,tickers,hours,minutes,method="1",p1=0.01,p2=0.0):
        ts = {}  
        newsLinks = []
        for tick in tickers:
            newsLinks.extend(self.db.getNewsPathLanugageTicker(lang,tick))
        
        
    
        for path in newsLinks:
            split = path.split("\\")
            date = self.db.getDateFromName(split[len(split)-1])
            time = self.db.getTimeFromName(split[len(split)-1])
            tick = self.db.getCategoryFromName(split[len(split)-1])
            ticker = self.tickers.getTicker(tick)
            if ticker.isDateTradingDay(date) and ticker.isTradeInNextHourMin(date, time, hours, minutes):
                
                values =  self.findValuesIntra(ticker, date, time, hours, minutes)
                if values != {}:
                    prices=values["prices"]                    
                    high=values["high"]
                    low=values["low"]
                    
                    
                    cl=None
                    if method=="1":
                        cl = self.method1(prices, high, low, p1,p2)
                    elif method=="2":
                        cl = self.method2(prices, high, low, p1)
                    
                    if cl != None:
                        ts[path]=([path,cl])
        
        return ts
    
    def generalMethodIntraTwo(self,lang,tickers,start,hours,minutes,method="1",p1=0.01,p2=0.0):
        ts = {}  
        newsLinks = []
        for tick in tickers:
            newsLinks.extend(self.db.getNewsPathLanugageTicker(lang,tick))
        
        
    
        for path in newsLinks:
            split = path.split("\\")
            date = self.db.getDateFromName(split[len(split)-1])
            time = self.db.getTimeFromName(split[len(split)-1])
            tick = self.db.getCategoryFromName(split[len(split)-1])
            ticker = self.tickers.getTicker(tick)
            
            #print time
            start2=int(time[0:2])-int(start)
            start2=str(start2)
            #if len(start2)==1: start2="0"+start2
            time=start2+time[2:]
            #print time
            if ticker.isDateTradingDay(date) and ticker.isTradeInNextHourMin(date, time, hours, minutes):
                
                #print "ok"
                
                values =  self.findValuesIntra(ticker, date, time, hours, minutes)
                #print values
                if values != {}:
                    #print "ok"
                    prices=values["prices"]                    
                    high=values["high"]
                    low=values["low"]
                    #print len(prices)
                    
                    cl=None
                    if method=="1":
                        cl = self.method1(prices, high, low, p1,p2)
                    elif method=="2":
                        cl = self.method2(prices, high, low, p1)
                    
                    if cl != None:
                        ts[path]=([path,cl])
        print len(ts)
        return ts
            
    #TODO: News published on non trading days is not working--FIX?
    def generalMethodDailyOne(self,lang,tickers=[],daysForward=13,method="1",p1=0.01,p2=0.0,openTime=9000,closeTime=17200):      
        ts = {}  
        
        newsLinks=[]
        for tick in tickers:
            newsLinks.extend(self.db.getNewsPathLanugageTicker(lang,tick))
                
        for path in newsLinks:
            split = path.split("\\")
            date = self.db.getDateFromName(split[-1])
            tick = self.db.getCategoryFromName(split[-1])
            ticker = self.tickers.getTicker(tick)
            if ticker.isDateTradingDay(date):
                values = self.findValues(self.db.getDateFromName(split[len(split)-1]), 
                                         self.db.getTimeFromName(split[len(split)-1]), 
                                         self.db.getCategoryFromName(split[len(split)-1]), daysForward, openTime, closeTime)
               
                prices=values["prices"]
                high=values["high"]
                low=values["low"]
                
                
                cl=None
                if method=="1":
                    cl = self.method1(prices, high, low, p1,p2)
                elif method=="2":
                    cl = self.method2(prices, high, low, p1)
                
                if cl != None:
                    ts[path]=([path,cl])
        
        return ts
    
    def generalMethodDailyTwo(self,lang,tickers=[],daysForward=13,method="1",p1=0.01,p2=0.0,openTime=900,closeTime=1820):      
        ts = {}  
        newsLinks = self.db.getNewsPathLanugage(lang)
        if len(tickers)>0:
            newsLinks=[]
            for tick in tickers:
                newsLinks.extend(self.db.getNewsPathLanugageTicker(lang,tick))
                
        for path in newsLinks:
            #print link
            #text=self.tickers.getTicker(tick).getNewsAllTextFromFilename(Constants.PATH_NEWS+path)
            split = path.split("\\")
            date = self.db.getDateFromName(split[len(split)-1])
            tick = self.db.getCategoryFromName(split[len(split)-1])
            ticker = self.tickers.getTicker(tick)
            if ticker.isDateTradingDay(date):
                values = self.findValues2(self.db.getDateFromName(split[len(split)-1]), 
                                         self.db.getTimeFromName(split[len(split)-1]), 
                                         self.db.getCategoryFromName(split[len(split)-1]), daysForward, openTime, closeTime)
                start=values["start"]
                after=values["after"]
                high=values["high"]
                low=values["low"]
                    
                #print values
                
                prices = []
                
                for s in start: prices.append(s)
                for c in after: prices.append(c)
                
                #print len(prices)
                
                cl=None
                if method=="1":
                    cl = self.method1(prices, high, low, p1,p2)
                    #print cl
                elif method=="2":
                    cl = self.method2(prices, high, low, p1)
                
                if cl != None:
                    ts[path]=([path,cl])
        
        return ts
        
        
        
    
    def compareTrainingsets(self,ts1,ts2):
        hit,miss=0,0
        pathHit={}
        for i in ts1.keys():
            if i in ts2.keys():
                s1=ts1[i]
                s2=ts2[i]
                if s1[1]==s2[1]:
                    hit+=1
                    pathHit[s1[0]]=s1
                else: miss+=1
        print "hit: "+str(hit)+", miss: "+str(miss)+" and total: "+str(hit+miss)+" | ts1 size: "+str(len(ts1))+" ts2 size: "+str(len(ts2))
        return pathHit
    
    """
    If both the same, label as that
    If one zero and other not, then label as the one not zero
    If not the same, and none is zero, then remove
    """
    def compareTrainingsetsTwo(self,ts1,ts2):
        hit,miss=0,0
        pathHit={}
        for i in ts1.keys():
            if i in ts2.keys():
                s1=ts1[i]
                s2=ts2[i]
                notZero=0
                zero=99
                if s1[1]!=0: notZero=s1[1]
                elif s2[1]!=0: notZero=s2[1]
                if s1[1]==0: zero=s1[1]
                elif s2[1]==0: zero=s2[1]
                if s1[1]==s2[1] or (notZero!=0 and zero==0):
                    hit+=1
                    pathHit[s1[0]]=[s1[0],notZero]
                else: miss+=1
        print "hit: "+str(hit)+", miss: "+str(miss)+" and total: "+str(hit+miss)+" | ts1 size: "+str(len(ts1))+" ts2 size: "+str(len(ts2))
        return pathHit
    
    def compareTrainingsetsThree(self,before,after):
        hit,miss=0,0
        ts={}
        for i in before.keys():
            if i in after.keys():
                s1=before[i]
                s2=after[i]
                sent=Constants.SENTIMENT_NUT
                if s1[1]==Constants.SENTIMENT_POS and s2[1]!=Constants.SENTIMENT_NEG: sent=s1[1]
                elif s1!=Constants.SENTIMENT_POS and s2[1]==Constants.SENTIMENT_NEG: sent=s2[1]
                ts[s1[0]]=[s1[0],sent]
            else: ts[s1[0]]=[s1[0],Constants.SENTIMENT_NUT]
        #print "hit: "+str(hit)+", miss: "+str(miss)+" and total: "+str(hit+miss)+" | ts1 size: "+str(len(before))+" ts2 size: "+str(len(after))
        return ts
    
    def storeTrainingSet(self,set,name):
        if not os.path.exists(Constants.PATH_TRAINING_SET):
            os.makedirs(Constants.PATH_TRAINING_SET)
        
        file = open(Constants.PATH_TRAINING_SET+name+".txt", 'w')    
        doc =""
        for s in set.values():
            doc+="\n<doc>"
            doc+="\n<file>\n"+s[0]+"\n</file>"
            doc+="\n<class>\n"+str(s[1])+"\n</class>"
            doc+="\n</doc>\n"
        file.write(doc)
        
        file.close()
        
    def loadTrainingSet(self,name):
        f = open(Constants.PATH_TRAINING_SET+name+".txt", "r")
        text = str(f.read())
        f.close()
        soup = BeautifulSoup(text)
        ts = {}       
        for link in soup.findAll('doc'):
            file =""
            cl=0
            soup2 = BeautifulSoup(str(link))
            for i in soup2.findAll('file'):
                file = i.contents[0].strip()
                while file[-1]!="t": file=file[:-1]
            for i in soup2.findAll('class'):
                cl = int(i.contents[0].strip())
            ts[file]=((file,cl))        
        return ts
    
    
    
    #Like newsCAT - No Mover: avg price change less than a
    #Pos: avg price change more than a in pos direction and max high value more than b
    #Neg: oposite of Pos
    #Uses prices at publication and a given duration after
    def method1(self,prices,highs,lows,a,b):
        #try:
        if len(prices)>0:
            avg=0
            for p in prices:
                avg+=float(p)
            avg=avg/len(prices)
            org = float(prices[0])
            dif = avg-org
            a = org*a
            b = org*b
            if abs(dif)>a:
                max = False
                if dif<0:
                    for i in lows:
                        if (org-float(i))>b: max=True
                if dif>0:
                    for i in highs:
                        if (float(i)-org)>b: max=True
                if max and dif<0: return -1
                elif max and dif>0: return 1    
                else: return 0
            else:
                return 0
        #else:return 0
    
    #TODO: currently not working. Prices not in order for daily. FIX
    def method2(self,prices,highs,lows,slope):
        #print len(prices)
        sp = HelperMethods.getLeastSquareBestFitLineSlope(prices)
        sh = HelperMethods.getLeastSquareBestFitLineSlope(highs)
        sl = HelperMethods.getLeastSquareBestFitLineSlope(lows)
        
        if sp>slope and sh>0 and sl>0: return 1
        elif sp<-slope and sh<0 and sl<0: return -1
        else: return 0
        
    """
    #Same as method1, but also checks if prices change direction from before and after publication    
    def method1_1(self,prices,highs,lows,before,beforeHighs,beforeLows,a,b):
        classAfter = self.method1(prices, highs, lows, a,b)
        classBefore = self.method1(before, beforeHighs, beforeLows, a,b)
        if classAfter == 1 and classBefore != 1: return 1
        elif classAfter == -1 and classBefore != -1: return -1
        else: return 0
    
    #Same as method2, but also checks if prices change direction from before and after publication
    def method2_1(self,prices,highs,lows,before,beforeHighs,beforeLows,slope):
        classAfter = self.method2(prices, highs, lows, slope)
        classBefore = self.method2(before, beforeHighs, beforeLows, slope)
        if classAfter == 1 and classBefore != 1: return 1
        elif classAfter == -1 and classBefore != -1: return -1
        else: return 0
    """
    
    
   
   
    #################### MOVE TO OTHER CLASS ##############################
    
    def featSetsToFreq(self,sets):
        freq={}
        for set in sets:
            for term in set:
                if term not in freq.keys():
                    freq[term]=1
                else: freq[term]=freq[term]+1
        return freq
    
    #TODO: TS is changed to dict. FIX
    def documentSelection(self,ts, size = 1000, source="all"):
        pos=[]
        neg=[]
        nut=[]
        dict=set([])
        cpos,cneg,cnut=0,0,0
        holder=[]
        print "Pick n number of pos, neg and nutral docs to process"
        if size > 0:
            while cpos<size and cneg<size and cnut<size:
                d = ts.values()[random.randint(0,len(ts.values())-1)] # Might chose same multiple time. TODO: FIX
                if d[1]==-1 and cneg<size:
                    holder.append(d)
                    cneg+=1
                elif d[1]==0 and cnut<size:
                    holder.append(d)
                    cnut+=1
                elif d[1]==1 and cpos<size:
                    holder.append(d)
                    cpos+=1
        else:
            holder = ts.values()
        print "Finish picking docs to process"
        print "Collect tokens in chosen docs"
        for d in holder:
            text = self.dataConnector.getNewsAllTextFromFilename(Constants.PATH_NEWS+d[0])
            doc = NewsArticleParseHelpers.getText(text)
            if source == NewsArticleParseHelpers.getSource(text) or source == "all":            
                tokens = nltk.word_tokenize(doc.lower())
                #stemmer = nltk.SnowballStemmer("norwegian")
                #tokens = [stemmer.stem(t) for t in tokens]
                #tok=[]
                import string
                tokens = [t for t in tokens if all(c in string.letters for c in t) and t not in nltk.corpus.stopwords.words('norwegian')]
                #tokens = nltk.trigrams(tokens)
                #tokens = nltk.bigrams(tokens)
                if d[1]==1: pos.append(set(tokens))
                elif d[1]==0: nut.append(set(tokens))
                elif d[1]==-1: neg.append(set(tokens))
                dict = dict.union(set(tokens))
        print "Finish finding tokens"
        print "Start chisuare"
        spos,sneg,snut={},{},{}
        negnut=neg+nut
        posnut=pos+nut
        negpos=neg+pos
        print len(dict)
        count=0
        for term in dict:
            print count
            count+=1
            #spos[term]=FSMetric.chiSquare(term, pos, negnut)
            #sneg[term]=FSMetric.chiSquare(term, neg, posnut)
            #snut[term]=FSMetric.chiSquare(term, nut, negpos)
            spos[term]=FSMetric.TF(term, self.featSetsToFreq(pos), self.featSetsToFreq(negnut))
            sneg[term]=FSMetric.TF(term, self.featSetsToFreq(neg), self.featSetsToFreq(posnut))
            snut[term]=FSMetric.TF(term, self.featSetsToFreq(nut), self.featSetsToFreq(negpos))
        
        from operator import itemgetter
        po=sorted(spos.iteritems(), key=itemgetter(1), reverse=True)
        print po[:10]
        ne=sorted(sneg.iteritems(), key=itemgetter(1), reverse=True)
        print ne[:10]
        nu=sorted(snut.iteritems(), key=itemgetter(1), reverse=True)
        print nu[:10]
        
        return (spos,sneg,snut)
        

    
    

if __name__=="__main__":
    s =NewsTrainingSetCreator()
    
    
    #list = ["BWO","DNO","FRO","PGS","SDRL","SEVAN","SIOFF","STL","TGS"]
    
    list=[]
    
    cl = str(ConfigAccess.configAccess("ts","companies"))
    #print cl
    spli= cl.split(" ")
    for i in spli: list.append(i)
    
    alpha=float(ConfigAccess.configAccess("ts","alpha"))
    beta=float(ConfigAccess.configAccess("ts","beta"))
    name = str(ConfigAccess.configAccess("ts","name"))
    
    tm=str(ConfigAccess.configAccess("ts","timing_method"))
        
    
    ts1={}
    if tm=="after":
        ts1 = s.generalMethodDailyTwo("no",list,1,"1",0.01,0.02)
    elif tm=="before":
        ts1 = s.generalMethodDailyOne("no",list,1,"1",0.01,0.02)
    
    s.storeTrainingSet(ts1, name)
    
    
    
    #ts2 = s.generalMethodDailyTwo("no",list,1,"1",0.01,0.02)
    #ts2 = s.generalMethodIntraTwo("no",list,"01","03","00","1",0.005,0.01)
    #s.storeTrainingSet(ts2, "2twoIntra2Hhour0,005-0,01")
    #ts2 = s.generalMethodIntraOne("no",list,"02","00","1",0.005,0.01)
    #s.storeTrainingSet(ts2, "intra2Hhour0,005-0,01")
    #ts2 = s.generalMethodIntraTwo("no",list,"01","02","00","1",0.01,0.02)
    #s.storeTrainingSet(ts2, "2twoIntra1Hhour0,01-0,02")
    #ts2 = s.generalMethodDailyTwo("no",list,1,"1",0.01,0.03)
    #s.storeTrainingSet(ts2, "2twoDaily1days0,01-0,03")
    #ts2 = s.generalMethodDailyTwo("no",list,5,"1",0.03,0.05)
    #s.storeTrainingSet(ts2, "2twoDaily5days0,03-0,05")
    
    #ts2 = s.generalMethodDailyTwo("no",list,2,"1",0.01,0.03)
    #s.storeTrainingSet(ts2, "twoDaily2days0,01-0,03")
    ##ts2 = s.generalMethodDailyTwo("no",list,2,"1",0.02,0.04)
    #s.storeTrainingSet(ts2, "twoDaily2days0,02-0,04")
    #ts2 = s.generalMethodDailyTwo("no",list,2,"1",0.03,0.05)
    #s.storeTrainingSet(ts2, "twoDaily2days0,03-0,05")
    
    #s.storeTrainingSet(ts, "OIL3")
    #print len(ts1)
    #s.storeTrainingSet(tsc, "comp1")
    
    
    print "Doc pre classifying done"
    print "Start doc selection"
    #ts = s.loadTrainingSet("comp1")
    #s.documentSelection(ts,-1)
    
    