#!/usr/bin/env python


"""
Originaly from svmlib, but it is hacked to work with this setup. 
Treading did not work, so most of it is changed. A new class will be better, and cleener.
"""

from __future__ import division
import numpy as np
import matplotlib.cm as cm
import  matplotlib.pyplot as plt
import pylab

from matplotlib.patches import Patch
#from pylab import *

import os, sys, traceback
import getpass
from threading import Thread
from subprocess import *

if(sys.hexversion < 0x03000000):
	import Queue
else:
	import queue as Queue


# svmtrain and gnuplot executable

#is_win32 = (sys.platform == 'win32')
#if not is_win32:
#       svmtrain_exe = "../svm-train"
#       gnuplot_exe = "/usr/bin/gnuplot"
#else:
# example for windows
svmtrain_exe = r"c:\libsvm-3.0\windows\svm-train.exe"
gnuplot_exe = r"c:\gnuplot\binary\pgnuplot.exe"

# global parameters and their default values

fold = 5
c_begin, c_end, c_step = -5,  15, 2
g_begin, g_end, g_step =  3, -15, -2
global dataset_pathname, dataset_title, pass_through_string
global out_filename, png_filename

# experimental

telnet_workers = []
ssh_workers = []
nr_local_worker = 1

# process command line options, set global parameters
def process_options(argv=sys.argv):

    global fold
    global c_begin, c_end, c_step
    global g_begin, g_end, g_step
    global dataset_pathname, dataset_title, pass_through_string
    global svmtrain_exe, gnuplot_exe, gnuplot, out_filename, png_filename
    
    usage = """\
Usage: grid.py [-log2c begin,end,step] [-log2g begin,end,step] [-v fold] 
[-svmtrain pathname] [-gnuplot pathname] [-out pathname] [-png pathname]
[additional parameters for svm-train] dataset"""

    if len(argv) < 2:
        print(usage)
        sys.exit(1)
    print "usage printed"
    dataset_pathname = argv[-1]
    dataset_title = os.path.split(dataset_pathname)[1]
    out_filename = "out.out"
    png_filename = "png.png"
    pass_through_options = []

    i = 0
    while i < len(argv) - 1:
        if argv[i] == "-log2c":
            i = i + 1
            (c_begin,c_end,c_step) = map(float,argv[i].split(","))
            print c_begin,c_end,c_step
        elif argv[i] == "-log2g":
            i = i + 1
            (g_begin,g_end,g_step) = map(float,argv[i].split(","))
            print g_begin,g_end,g_step
        elif argv[i] == "-v":
            i = i + 1
            fold = argv[i]
        elif argv[i] in ('-c','-g'):
            print("Option -c and -g are renamed.")
            print(usage)
            sys.exit(1)
        elif argv[i] == '-svmtrain':
            i = i + 1
            svmtrain_exe = argv[i]
        elif argv[i] == '-gnuplot':
            i = i + 1
            gnuplot_exe = argv[i]
        elif argv[i] == '-out':
            i = i + 1
            out_filename = argv[i]
        elif argv[i] == '-png':
            i = i + 1
            png_filename = argv[i]
        else:
            pass_through_options.append(argv[i])
        i = i + 1

    pass_through_string = " ".join(pass_through_options)
    #print gnuplot_exe
    #print svmtrain_exe
    #print dataset_pathname
    assert os.path.exists(svmtrain_exe),"svm-train executable not found"    
    assert os.path.exists(gnuplot_exe),"gnuplot executable not found"
    assert os.path.exists(dataset_pathname),"dataset not found"
    gnuplot = Popen(gnuplot_exe,stdin = PIPE).stdin


def range_f(begin,end,step):
    # like range, but works on non-integer too
    seq = []
    while True:
        if step > 0 and begin > end: break
        if step < 0 and begin < end: break
        seq.append(begin)
        begin = begin + step
    return seq

def permute_sequence(seq):
    n = len(seq)
    if n <= 1: return seq

    mid = int(n/2)
    left = permute_sequence(seq[:mid])
    right = permute_sequence(seq[mid+1:])

    ret = [seq[mid]]
    while left or right:
        if left: ret.append(left.pop(0))
        if right: ret.append(right.pop(0))

    return ret
   
def redraw2(db,xmin,xmax,ymin,ymax,tofile=False):
    
    x,y,f=[],[],[]
    for d in db:
        x.append(d[0])
        y.append(d[1])
        f.append(d[2])

    
    plt.subplots_adjust(hspace=0.5)
    plt.subplot(121)
    plt.hexbin(x,y, f,15)
    plt.axis([xmin, xmax, ymin, ymax])
    plt.title("Performance of SVM")
    
    cb = plt.colorbar()
    cb.set_label('accuracy')

    plt.show()

def fileToDb(filename):
    file = open(filename, 'r')
    db=[]
    for line in file.readlines():
        h=line.split(" ")
        db.append([h[0],h[1],h[2]])
    return db	

def redraw(db,best_param,tofile=False):
    if len(db) == 0: return
    begin_level = round(max(x[2] for x in db)) - 3
    step_size = 0.5

    best_log2c,best_log2g,best_rate = best_param

    if tofile:
        gnuplot.write( "set term png transparent small\n".encode())
        gnuplot.write( ("set output \"%s\"\n" % png_filename.replace('\\','\\\\')).encode())
        #gnuplot.write("set term postscript color solid\n".encode())
        #gnuplot.write(("set output \"%s.ps\"\n" % dataset_title).encode())
    else: #if is_win32:
        gnuplot.write("set term windows\n".encode())
    #else:
    #    gnuplot.write( "set term x11\n".encode())
    gnuplot.write("set xlabel \"log2(C)\"\n".encode())
    gnuplot.write("set ylabel \"log2(gamma)\"\n".encode())
    gnuplot.write(("set xrange [%s:%s]\n" % (c_begin,c_end)).encode())
    gnuplot.write(("set yrange [%s:%s]\n" % (g_begin,g_end)).encode())
    gnuplot.write("set contour\n".encode())
    gnuplot.write(("set cntrparam levels incremental %s,%s,100\n" % (begin_level,step_size)).encode())
    gnuplot.write("unset surface\n".encode())
    gnuplot.write("unset ztics\n".encode())
    gnuplot.write("set view 0,0\n".encode())
    gnuplot.write(("set title \"%s\"\n" % dataset_title).encode())
    gnuplot.write("unset label\n".encode())
    #gnuplot.write(("set label \"Best C = %s  gamma = %s  accuracy = %s%%\" \
    #              at screen 0.5,0.85 center\n" % \
    #              (best_log2c, best_log2g, best_rate)).encode())
    #gnuplot.write(("set label \"C = %s  gamma = %s\""
    #              " at screen 0.5,0.8 center\n" % (2**best_log2c, 2**best_log2g)).encode())
    gnuplot.write("splot \"-\" \n".encode())
    #gnuplot.write("set pm3d map")
    


    
    db.sort(key = lambda x:(x[0], -x[1]))

    prevc = db[0][0]
    for line in db:
        if prevc != line[0]:
            gnuplot.write("\n".encode())
            prevc = line[0]
        gnuplot.write(("%s %s %s\n" % line).encode())
    gnuplot.write("e\n".encode())
    gnuplot.write("\n".encode()) # force gnuplot back to prompt when term set failure
    gnuplot.flush()


def calculate_jobs():
    c_seq = permute_sequence(range_f(c_begin,c_end,c_step))
    g_seq = permute_sequence(range_f(g_begin,g_end,g_step))
    nr_c = float(len(c_seq))
    nr_g = float(len(g_seq))
    i = 0
    j = 0
    jobs = []

    while i < nr_c or j < nr_g:
        if i/nr_c < j/nr_g:
            # increase C resolution
            line = []
            for k in range(0,j):
                line.append((c_seq[i],g_seq[k]))
            i = i + 1
            jobs.append(line)
            #print line
        else:
            # increase g resolution
            line = []
            for k in range(0,i):
                line.append((c_seq[k],g_seq[j]))
            j = j + 1
            jobs.append(line)
            #print line
    return jobs

class WorkerStopToken:  # used to notify the worker to stop
        pass

class Worker(Thread):
    def __init__(self,name,job_queue,result_queue):
        Thread.__init__(self)
        self.name = name
        self.job_queue = job_queue
        self.result_queue = result_queue
    def run(self):
        while True:
            (cexp,gexp) = self.job_queue.get()
            if cexp is WorkerStopToken:
                self.job_queue.put((cexp,gexp))
                # print 'worker %s stop.' % self.name
                break
            try:
            	print 2.0**cexp,2.0**gexp
                rate = self.run_one(2.0**cexp,2.0**gexp)
                if rate is None: raise RuntimeError("get no rate")
            except:
                # we failed, let others do that and we just quit
            
                traceback.print_exception(sys.exc_info()[0], sys.exc_info()[1], sys.exc_info()[2])
                
                self.job_queue.put((cexp,gexp))
                print('worker %s quit.' % self.name)
                break
            else:
                self.result_queue.put((self.name,cexp,gexp,rate))

class LocalWorker(Worker):
    def run_one(self,c,g):
        cmdline = '%s -c %s -g %s -v %s %s %s' % \
          (svmtrain_exe,c,g,fold,pass_through_string,dataset_pathname)
        result = Popen(cmdline,shell=True,stdout=PIPE).stdout
        for line in result.readlines():
            if str(line).find("Cross") != -1:
                return float(line.split()[-1][0:-1])

class SSHWorker(Worker):
    def __init__(self,name,job_queue,result_queue,host):
        Worker.__init__(self,name,job_queue,result_queue)
        self.host = host
        self.cwd = os.getcwd()
    def run_one(self,c,g):
        cmdline = 'ssh -x %s "cd %s; %s -c %s -g %s -v %s %s %s"' % \
          (self.host,self.cwd,
           svmtrain_exe,c,g,fold,pass_through_string,dataset_pathname)
        result = Popen(cmdline,shell=True,stdout=PIPE).stdout
        for line in result.readlines():
            if str(line).find("Cross") != -1:
                return float(line.split()[-1][0:-1])

class TelnetWorker(Worker):
    def __init__(self,name,job_queue,result_queue,host,username,password):
        Worker.__init__(self,name,job_queue,result_queue)
        self.host = host
        self.username = username
        self.password = password        
    def run(self):
        import telnetlib
        self.tn = tn = telnetlib.Telnet(self.host)
        tn.read_until("login: ")
        tn.write(self.username + "\n")
        tn.read_until("Password: ")
        tn.write(self.password + "\n")

        # XXX: how to know whether login is successful?
        tn.read_until(self.username)
        # 
        print('login ok', self.host)
        tn.write("cd "+os.getcwd()+"\n")
        Worker.run(self)
        tn.write("exit\n")               
    def run_one(self,c,g):
        cmdline = '%s -c %s -g %s -v %s %s %s' % \
          (svmtrain_exe,c,g,fold,pass_through_string,dataset_pathname)
        result = self.tn.write(cmdline+'\n')
        (idx,matchm,output) = self.tn.expect(['Cross.*\n'])
        for line in output.split('\n'):
            if str(line).find("Cross") != -1:
                return float(line.split()[-1][0:-1])


import LocalDataConnector, NewsArticleParseHelpers,ConfigAccess,HelperMethods, Constants
import os,re,math
import FSMetric, DBManager,TrainingSetCreator
import nltk
import random
import TickerManager
from BeautifulSoup import BeautifulSoup
import ClassifierOne,TextPreprocessingTools
import random
import operator
import DocData
from sets import Set
import pickle, TrainingSetCreator,DocumentSelection
import Evaluation, ClassifierTwo, DocPrepEngine, CategorizationEngine,DocumentClusterRefining
import TradingEngine



def classifier(docs,SVMoptions=""):       
    ###########3
    #Controll Param
   
    
    NRsimulations=5
    
    #docSelThresh=50.0
    trainingSetDiv=0.7
    
    #Varaibles
    docPrep=DocPrepEngine.DocPrepEngine()
    ce = CategorizationEngine.CategorizationEngine() 
    #############
    
    ####
    pos,nut,neg=docPrep.divideDocsInPosNeutNeg(docs)
    min1=min(len(pos),len(neg),len(nut))
    docs=pos[:min1]+nut[:min1]+neg[:min1]
    
    #yManualTest,xManualTest=ce.makeClassifierSetFromDocs(docsManual)
    acc=0.0
    for i in xrange(NRsimulations):
        ############
        #shuffle
        random.shuffle(docs)
        if len(docs)>1000: docs=docs[:1000]
        training=docs[:int(len(docs)*trainingSetDiv)]
        testing=docs[int(len(docs)*trainingSetDiv):]
        #ce.createVocabularyC1(training, vocabSize)
        ce.trainingMethodOne(training,SVMoptions)               #TRAIN
        p_label, p_acc, p_val = ce.testMethodOne(testing)
        acc+=p_acc[0]
    return acc/float(NRsimulations)



if __name__=="__main__":

    #redraw2(fileToDb("tsout.txt"),0,8,0,6)
    # set parameters

    #print "start process options"
    process_options(["-log2c","0.1,4.1,0.2","-log2g","0.1,3.1,0.2","-svmtrain","c:\\libsvm-3.0\\windows\\svm-train.exe",
				"-gnuplot","c:\\gnuplot\\binary\\pgnuplot.exe",
				"-out","gridout.out","-png","gridpngout.png","heart_scale"])
    
    print "process options done"

    # put jobs in queue

    jobs = calculate_jobs()
    job_queue = Queue.Queue(0)
    result_queue = Queue.Queue(0)
    print "intervals done"
    
    
    for line in jobs:
        for (c,g) in line:
            job_queue.put((c,g))

    job_queue._put = job_queue.queue.appendleft

    #print job_queue
    print "jobs in queue"
    # fire telnet workers

    
    docPrep=DocPrepEngine.DocPrepEngine()
    docs=docPrep.loadPrepDocs("2twoDaily5days0,03-0,05")
    clr=DocumentClusterRefining.DocumentClusterRefining()
    docs=clr.refining(docs,1)
    
    done_jobs = {}
    count=0
    for line in jobs:
        print str(count)+" of "+str(len(jobs))
        count+=1
        for (c,g) in line:
            svmoption='-s 0 -t 2 -c %s -g %s' % (c,g)
            done_jobs[(c,g)]= classifier(docs,svmoption)
    



    db = []
    best_rate = -1.0
    best_c1,best_g1 = None,None

    for line in jobs:
        for (c,g) in line:
            print done_jobs[(c,g)]
            if done_jobs[(c,g)]>best_rate:
                best_rate=done_jobs[(c,g)]
                best_c1=c
                best_g1=g        	            
            db.append((c,g,done_jobs[(c,g)]))
            
    redraw2(db,0,4,0,3)
    #redraw(db,[best_c1, best_g1, best_rate],True)
    
    s=""
    for x in db:
        s+=str(db[0])+" "+str(db[1])+" "+str(db[2])+"\n"
    file = open("tsout.txt", 'w')
    file.write(s)
    #print best_rate.best_c1,best_g1

